const college_passout = require("./../models/collegePassout");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newCollege_passout = new college_passout({
    collage_passout_id: req.body.collage_passout_id,
    collage_passout_name: req.body.collage_passout_name,
    collage_passout_is_deleted: req.body.collage_passout_is_deleted,
    collage_passout_added_by: req.body.collage_passout_added_by,
    collage_passout_order: req.body.collage_passout_order,
    collage_passout_status: req.body.collage_passout_status,
  });
  college_passout.addCollege_passout(newCollege_passout, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "College_passout added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
    // Initialize all inputs
    const id= req.body._id;
  college_passout.getCollege_passout(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      }else{
          rc.setResponse(res, {
              msg: 'No data found by this id'
          })
      }
    }
  });
};

module.exports.getAll=(req, res)=>{
    college_passout.getAllCollege_passout((err, data)=>{
        if(err){
            rc.setResponse(res,{
                msg: err.message,
                data: err
            })
        }else{
            if(data){
                rc.setResponse(res, {
                    success: true,
                    msg: 'All data fetched successfully',
                    data: data
                })
            }else{
                rc.setResponse(res,{
                    msg: 'No data present'
                })
            }
        }
    })
}
module.exports.update = (req, res) => {
    const id= req.body._id;

  college_passout.getCollege_passout(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        data.lastChanges = {};

        if (req.body.college_passout_name) {
          isChange = true;
          data.lastChanges.college_passout_name = data.college_passout_name;
          data.college_passout_name = req.body.college_passout_name;
        }
        
        if(req.body.collage_passout_is_deleted){
            isChange= true;
            data.lastChanges.collage_passout_is_deleted= data.collage_passout_is_deleted;
            data.collage_passout_is_deleted = req.body.collage_passout_is_deleted;
        }
        
        if(req.body.collage_passout_order){
            isChange= true;
            data.lastChanges.collage_passout_order= data.collage_passout_order;
            data.collage_passout_order = req.body.collage_passout_order;
        }
        if(req.body.collage_passout_status){
            isChange= true;
            data.lastChanges.collage_passout_status= data.collage_passout_status;
            data.collage_passout_status = req.body.collage_passout_status;
        }
        
        
        if (isChange) {
            
          college_passout.addCollege_passout(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
    const id= req.params._id;
  college_passout.deleteCollege_passout(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
