const Event = require("./../models/event");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newEvent = new Event({
    Title: req.body.Title,
    shortTitle: req.body.shortTitle,
    description: req.body.description,
    live: req.body.live,
    running: req.body.running,
    caste: req.body.caste,
    incomeRange: req.body.incomeRange,
    limit: req.body.limit,
    startedAt: req.body.startedAt,
    endedAt: req.body.endedAt,
           
         });
         Event.addEvent(newEvent, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      })
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Event added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.body._id;
  Event.getEvent(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getAll = (req, res) => {
  Event.getAllEvents((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  Event.getEvent(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        if(req.body.Title){
            isChange = true;
            data.Title = req.body.Title
        }
        if(req.body.shortTitle){
            isChange = true;
            data.shortTitle = req.body.shortTitle
        }
        if(req.body.description){
            isChange = true;
            data.description = req.body.description
        }
        if(req.body.live){
            isChange = true;
            data.live = req.body.live
        }
        if(req.body.running){
            isChange = true;
            data.running = req.body.running
        }
        if(req.body.caste){
            isChange = true;
            data.caste = req.body.caste
        }
        if(req.body.incomeRange){
            isChange = true;
            data.incomeRange = req.body.incomeRange
        }
        if(req.body.limit){
            isChange = true;
            data.limit = req.body.limit
        }
        if(req.body.startedAt){
            isChange = true;
            data.startedAt = req.body.startedAt
        }
        if(req.body.endedAt){
            isChange = true;
            data.endedAt = req.body.endedAt
        }
        if(req.body.createdAt){
            isChange = true;
            data.createdAt = req.body.createdAt
        }
        if(req.body.updatedAt){
            isChange = true;
            data.updatedAt = req.body.updatedAt
        }
        if(isChange) {
          Event.addEvent(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  Event.deleteEvent(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
