const media = require("./../models/media");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newMedia = new media({
    media_id: req.body.media_id,
    media_image: req.body.media_image,
    media_type: req.body.media_type,
    media_is_deleted: req.body.media_is_deleted,
    media_order: req.body.media_order,
    media_added_by: req.body.media_added_by,
    media_created_on: req.body.media_created_on,
    media_status: req.body.media_status
         });
  media.addMedia(newMedia, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      })
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Media added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.body._id;
  media.getMedia(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getAll = (req, res) => {
  media.getAllMedia((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  media.deleteMedia(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
