const mother_tongue = require("./../models/motherTongue");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newMother_tongue = new mother_tongue({
    mother_tongue_id: req.body.mother_tongue_id,
    mother_tongue_name: req.body.mother_tongue_name,
    mother_tongue_slug: req.body.mother_tongue_slug,
    mother_tongue_added_by: req.body.mother_tongue_added_by,
    mother_tongue_is_deleted: req.body.mother_tongue_is_deleted,
    mother_tongue_order: req.body.mother_tongue_order,
    mother_tongue_status: req.body.mother_tongue_status,
         });
  mother_tongue.addMother_tongue(newMother_tongue, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      })
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Mother_tongue added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.body._id;
  mother_tongue.getMother_tongue(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.getAll = (req, res) => {
  mother_tongue.getAllMother_tongue((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  mother_tongue.getMother_tongue(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        data.lastChanges = {};

        if (req.body.mother_tongue_name) {
          isChange = true;
          data.lastChanges.mother_tongue_name = data.mother_tongue_name;
          data.mother_tongue_name = req.body.mother_tongue_name;
        }
            
        if(req.body.mother_tongue_slug){
            isChange= true;
            data.lastChanges.mother_tongue_slug = data.mother_tongue_slug;
            data.mother_tongue_slug = req.body.mother_tongue_slug;
        }
        
        if(req.body.mother_tongue_is_deleted){
            isChange= true;
            data.lastChanges.mother_tongue_is_deleted = data.mother_tongue_is_deleted;
            data.mother_tongue_is_deleted = req.body.mother_tongue_is_deleted;
        }
        
        if(req.body.mother_tongue_order){
            isChange= true;
            data.lastChanges.mother_tongue_order = data.mother_tongue_order;
            data.mother_tongue_order = req.body.mother_tongue_order;
        }
        if(req.body.mother_tongue_status){
            isChange= true;
            data.lastChanges.mother_tongue_status = data.mother_tongue_status;
            data.mother_tongue_status = req.body.mother_tongue_status;
        }
        if (isChange) {
            data.mother_tongue_updated_on = Date.now();
          mother_tongue.addMother_tongue(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.body._id;
  mother_tongue.deleteMother_tongue(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
