const otp = require("./../models/otp.js");
const rc = require("./../controllers/responseController");
const moment = require("moment");
const Mail = require("./../models/mail");
const request = require("request");

module.exports.sendOtp = (req, res) => {
  this.deleteExpiredOtps();
  var digits = '0123456789';
  let OTP = '';
  for (let i = 0; i < 6; i++) {
    OTP += digits[Math.floor(Math.random() * 10)];
  }
  console.log(OTP);

  otp.getOtpReference(req.body.reference, (err, refFound) => {
    if (err) {
      console.log("Error in matching reference");
      rc.setResponse(res, {
        msg: "Error in matching previous reference"
      })
    } else {
      if (refFound) {

        refFound.otp = OTP;
        refFound.createdAt = moment();
        mainOtp = refFound;


      } else {
        let newOtp = new otp({
          reference: req.body.reference,
          otp: OTP,
          referenceType: req.body.referenceType,
          createdAt: moment()
        });
        mainOtp = newOtp;
      }
      otp.addOtp(mainOtp, (err, data) => {
        if (err) {
          rc.setResponse(res, {
            msg: err.message,
            data: err
          });
        } else {
          if (req.body.referenceType === "Email") {
            var msg = `Your OTP is ${data.otp}`;
            Mail.sendMailSSNoReply(req.body.reference, msg, (err, response) => {
              if (err) {
                rc.setResponse(res, {
                  msg: "Error in sending mail",
                  data: err
                });
              } else {
                rc.setResponse(res, {
                  success: true,
                  msg: "Mail sent successfully",
                  data: data
                });
              }
            });
          }
          if (req.body.referenceType === "Mobile") {
            const mobile = req.body.reference;
            var msg = `Your OTP is ${data.otp}`;

            var url = `http://sms.hspsms.com/sendSMS?username=Worldclass&message={ MESSAGE }&sendername=SDISMN&smstype=TRANS&numbers={ NUMBER }&apikey=712b3dcd-d552-4bec-a2f9-ae31807fbd6e`;

            var arr = url.split("{ NUMBER }");
            var arr2 = arr[1].split("{ MESSAGE }")[0] + `${msg}`;
            arr = arr[0] + `${mobile}`;
            const newUrl = arr + arr2;
            request(newUrl, (error, response, body) => {
              if (error) {
                rc.setResponse(res, {
                  msg: "Error in sending message",
                  data: err
                });
              } else {
                rc.setResponse(res, {
                  success: true,
                  msg: "Message sent successfully"
                });
              }
            });
          }
          if (req.body.referenceType === 'Email/Mobile') {
            const splittedRef = req.body.reference.split('/');
            const email = splittedRef[0];
            const mobile = splittedRef[1];
            var msg = `Your OTP is ${data.otp}`;
            Mail.sendMailSSNoReply(email, msg, (err, response) => {
              if (err) {
                rc.setResponse(res, {
                  msg: "Error in sending mail",
                  data: err
                });
              } else {

                var msg = `Your OTP is ${data.otp}`;

                var url = `http://sms.hspsms.com/sendSMS?username=Worldclass&message={ MESSAGE }&sendername=SDISMN&smstype=TRANS&numbers={ NUMBER }&apikey=712b3dcd-d552-4bec-a2f9-ae31807fbd6e`;

                var arr = url.split("{ NUMBER }");
                var arr2 = arr[1].split("{ MESSAGE }")[0] + `${msg}`;
                arr = arr[0] + `${mobile}`;
                const newUrl = arr + arr2;
                request(newUrl, (error, response, body) => {
                  if (error) {
                    rc.setResponse(res, {
                      msg: "Error in sending message",
                      data: err
                    });
                  } else {
                    rc.setResponse(res, {
                      success: true,
                      msg: "OTP successfully sent on mail and mobile"
                    });
                  }
                });
              }
            });
          }
        }
      });
    }
  })

};

module.exports.verifyOtp = (req, res) => {
  const otpToMatch = req.body.otp;
  const reference = req.body.reference;
  otp.getOtpReference(reference, (err, ref) => {
    if (err) {
      rc.setResponse(res, {
        msg: 'Error in searching reference',
        data: err
      })
    } else {
      if (ref) {
        if (ref.otp === otpToMatch) {
          var currentTime = moment();
          var difference = currentTime.diff(moment(Date.parse(ref.createdAt)), 'minutes');
          console.log(difference);
          // if(difference<3){
          if (true) {
            rc.setResponse(res, {
              success: true,
              msg: 'Otp verified successfully',

            })
          } else {
            rc.setResponse(res, {
              msg: "OTP expired"
            })
          }

        } else {
          rc.setResponse(res, {
            msg: 'Otp does not match'
          })
        }
      } else {
        rc.setResponse(res, {
          msg: "Reference is not found"
        })
      }
    }
  })
  // otp.getOtpByName(otpToverify, (err, matchedOtp)=>{
  //     if(err){
  //         rc.setResponse(res,{
  //             msg: 'Error in searching otp',
  //             data: err
  //         })
  //     }else{
  //         if(matchedOtp[0]){
  //             var currentTime = moment();
  //             var difference = currentTime.diff(moment(Date.parse(matchedOtp[0].createdAt)), 'minutes');


  //             if(difference>2){
  //                 rc.setResponse(res,{
  //                     msg: "Sorry, this otp has expired"
  //                 })
  //             }else{
  //                 rc.setResponse(res,{
  //                     success: true,
  //                     msg: "Otp verified successfully"
  //                 })
  //             }
  //         }else{
  //             rc.setResponse(res,{
  //                 msg:"Sorry, no such otp found"
  //             })
  //         }
  //     }
  // })

}


module.exports.deleteExpiredOtps = (req, res) => {
  otp.getAllOtp((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: 'Error in getting old opts',
        data: err
      })
    } else {
      for (const otpTime of data) {
        // var currentTime = moment().format("dddd, MMMM Do YYYY, h:mm:ss a");
        var currentTime = moment();
        // console.log(currentTime);
        // console.log(otp.createdAt);
        var difference = currentTime.diff(moment(Date.parse(otpTime.createdAt)), 'minutes');

        if (difference > 15) {
          otp.deleteOtp(otpTime._id, (err, data) => {
            if (err) {
              rc.setResponse(res, {
                msg: 'Error in deleting otp',
                data: err
              })
            }
          })
        }
      }

    }
    // rc.setResponse(res,{
    //     success: true,
    //     msg: 'All expired deleted'
    // })
  })

}
module.exports.get = (req, res) => {
  const id = req.body._id;
  otp.getOtp(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  otp.getAllOtp((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.update = (req, res) => {
  const id = req.body._id;
  otp.getOtp(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        isChange = false;
        if (req.body.reference) {
          (isChange = true), (data.reference = req.body.reference);
        }
        if (req.body.otp) {
          (isChange = true), (data.otp = req.body.otp);
        }
        if (isChange) {
          data.createdOn = Date.now();
          otp.addOtp(data, (err, updatedData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Data updated successfully",
                data: updatedData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No changes provided"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  otp.deleteOtp(id, (err, deletedData) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (deletedData) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: deletedData
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
