const promo = require("./../models/promotional-page");
const rc = require("./responseController");

module.exports.add = (req, res) => {
  let newPromo = new promo({
    type: req.body.type,
    page_title: req.body.page_title,
    name: req.body.name,
    small_desc: req.body.small_desc,
    large_desc: req.body.large_desc,
    image_main: req.body.image_main,
    background_image: req.body.background_image,
    image: req.body.image
  });
  promo.addPromoPage(newPromo, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Promo page added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  // Initialize all inputs
  const id = req.body._id;
  promo.getPromoPage(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getCityPromo = (req, res) =>{
  promo.getCityPrompPages((err,data)=>{
    if(err){
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    }else{
      if(data){
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      }else{
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  })
}
module.exports.getCommunityPromo = (req, res) =>{
  promo.getCommunityPrompPages((err,data)=>{
    if(err){
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    }else{
      if(data){
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      }else{
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  })
}

module.exports.getAll = (req, res) => {
  promo.getAllPromo((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  promo.getPromoPage(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        if (req.body.type) {
          isChange = true;
          data.type = req.body.type;
        }
        if (req.body.page_title) {
          isChange = true;
          data.page_title = req.body.page_title;
        }
        if (req.body.name) {
          isChange = true;
          data.name = req.body.name;
        }
        if (req.body.small_desc) {
          isChange = true;
          data.small_desc = req.body.small_desc;
        }
        if (req.body.large_desc) {
          isChange = true;
          data.large_desc = req.body.large_desc;
        }
        if (req.body.image_main) {
          isChange = true;
          data.image_main = req.body.image_main;
        }
        if (req.body.background_image) {
          isChange = true;
          data.background_image = req.body.background_image;
        }
        if (req.body.image) {
          isChange = true;
          data.image = req.body.image;
        }
        if (isChange) {
          
          
          promo.addPromoPage(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  promo.deletePromo(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
