const ReligionMaster = require("../models/religion-master");
const rc = require("./responseController");


module.exports.getAllReligions= (req, res)=>{
    ReligionMaster.getAllReligions((err,data)=>{
        if (err) {
            rc.setResponse(res, {
              msg: err.message,
              data: err
            });
          } else {
            if (data) {
              rc.setResponse(res, {
                success: true,
                msg: "All religions fetched successfully",
                data: data
              });
            } else {
              rc.setResponse(res, {
                msg: "No data present"
              });
            }
          }
    })
}
module.exports.getAllCastes = (req, res)=>{
  const religion= req.params.religion;
  ReligionMaster.getAllCastes(religion,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All castes fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  })
}
module.exports.getAllDistinctCastes = (req, res)=>{
  ReligionMaster.getAllDistinctCastes((err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All castes fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  })
}
module.exports.getAllSubCastes = (req, res)=>{
  const religion= req.params.religion;
  const caste= req.params.caste;
  ReligionMaster.getAllSubCastes(religion,caste,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All sub castes fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  })
}
module.exports.getAllGotras = (req, res)=>{
  const religion= req.params.religion;
  const caste= req.params.caste;
  const subCaste= req.params.subCaste;
  ReligionMaster.getAllGotras(religion, caste,subCaste,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All gotras fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  })
}
module.exports.createReligion = (req, res)=>{
  let religion = new ReligionMaster({
    Religion : req.body.religion
  })
  ReligionMaster.createReligion(religion,(err, religion)=>{
    if(err){
      rc.setResponse(res,{
        msg: 'Error in creating religion',
        data: err
      })
    }else{
      rc.setResponse(res,{
        success: true,
        msg: 'Religion created successfully',
        data: religion
      })
    }
  })
}
module.exports.createCaste = (req, res)=>{
  let caste = new ReligionMaster({
    Religion: req.body.religion,
    Caste : req.body.caste
  })
  ReligionMaster.createCaste(caste,(err, caste)=>{
    if(err){
      rc.setResponse(res,{
        msg: 'Error in creating caste',
        data: err
      })
    }else{
      rc.setResponse(res,{
        success: true,
        msg: 'Caste created successfully',
        data: caste
      })
    }
  })
}
module.exports.createSubCaste = (req, res)=>{
  let subCaste = new ReligionMaster({
    Religion: req.body.religion,
    Caste: req.body.caste,
    SubCaste : req.body.subCaste
  })
  ReligionMaster.createSubCaste(subCaste,(err, subCaste)=>{
    if(err){
      rc.setResponse(res,{
        msg: 'Error in creating subCaste',
        data: err
      })
    }else{
      rc.setResponse(res,{
        success: true,
        msg: 'SubCaste created successfully',
        data: subCaste
      })
    }
  })
}
module.exports.createGotra = (req, res)=>{
  let gotra = new ReligionMaster({
    Religion: req.body.religion,
    Caste: req.body.caste,
    SubCaste : req.body.subCaste,
    Gotra : req.body.gotra
  })
  ReligionMaster.createGotra(gotra,(err, gotra)=>{
    if(err){
      rc.setResponse(res,{
        msg: 'Error in creating gotra',
        data: err
      })
    }else{
      rc.setResponse(res,{
        success: true,
        msg: 'Gotra created successfully',
        data: gotra
      })
    }
  })
}
module.exports.updateReligion =(req, res)=>{
  const religion = req.body.religion;
  const newReligion = req.body.newReligion;
  ReligionMaster.updateReligion(religion, newReligion,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Religion updated successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No religion to update"
        });
      }
    }
  })

  
}
module.exports.updateCaste =(req, res)=>{
  const religion = req.body.religion;
  const caste = req.body.caste;
  const newCaste = req.body.newCaste;
  ReligionMaster.updateCaste(religion, caste, newCaste,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Caste updated successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No caste to update"
        });
      }
    }
  })

  
}
module.exports.updateSubCaste =(req, res)=>{
  const religion = req.body.religion;
  const caste = req.body.caste;
  const subCaste = req.body.subCaste;
  const newSubCaste = req.body.newSubCaste;
  ReligionMaster.updateSubCaste(religion,caste,subCaste, newSubCaste,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "SubCaste updated successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No subCaste to update"
        });
      }
    }
  })

  
}
module.exports.updateGotra =(req, res)=>{
  const religion = req.body.religion;
  const caste = req.body.caste;
  const subCaste = req.body.subCaste;
  const gotra = req.body.gotra;
  const newGotra = req.body.newGotra;
  ReligionMaster.updateGotra(religion,caste,subCaste,gotra, newGotra,(err, data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Gotra updated successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No gotra to update"
        });
      }
    }
  })

  
}
module.exports.deleteReligion = (req, res)=>{
  
  const religion = req.params.religion;
  ReligionMaster.deleteReligion(religion,(err,data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Religion deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No religion to delete"
        });
      }
    }
  })
}
module.exports.deleteCaste = (req, res)=>{
  const religion = req.params.religion;
  const caste = req.params.caste;
  ReligionMaster.deleteCaste(religion,caste,(err,data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Caste deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No caste to delete"
        });
      }
    }
  })
}
module.exports.deleteSubCaste = (req, res)=>{
  const religion = req.params.religion;
  const caste = req.params.caste;
  const subCaste = req.params.subCaste;
  ReligionMaster.deleteSubCaste(religion,caste,subCaste,(err,data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "SubCaste deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No subCaste to delete"
        });
      }
    }
  })
}
module.exports.deleteGotra = (req, res)=>{
  const religion = req.params.religion;
  const caste = req.params.caste;
  const subCaste = req.params.subCaste;
  const gotra = req.params.gotra;
  ReligionMaster.deleteGotra(religion, caste, subCaste,gotra,(err,data)=>{
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Gotra deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No gotra to delete"
        });
      }
    }
  })
}
module.exports.add = (req, res) => {
  let newReligionMaster = new ReligionMaster({
            Religion: req.body.Religion,
            Caste: req.body.Caste,
            SubCaste: req.body.SubCaste,
            Gotra: req.body.Gotra
         });
  ReligionMaster.addReligionMaster(newReligionMaster, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      })
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};
module.exports.get = (req, res) => {
    const id = req.params._id;
  ReligionMaster.getReligionMaster(id,(err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  ReligionMaster.getAllReligionMasters((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "All data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data present"
        });
      }
    }
  });
};
module.exports.update = (req, res) => {
  const id = req.body._id;

  ReligionMaster.getReligionMaster(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        let isChange = false;
        if(req.body.Religion){
            isChange = true;
            data.Religion = req.body.Religion
        }
        if(req.body.Caste){
            isChange = true;
            data.Caste = req.body.Caste
        }
        if(req.body.SubCaste){
            isChange = true;
            data.SubCaste = req.body.SubCaste
        }
        if(req.body.Gotra){
            isChange = true;
            data.Gotra = req.body.Gotra
        }
        if (isChange) {
            
            
          ReligionMaster.addReligionMaster(data, (err, newData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Details updated successfully",
                data: newData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No data to update"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.delete = (req, res) => {
  const id = req.params._id;
  ReligionMaster.deleteReligionMaster(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};

