const religion = require("./../models/religion.js");
const rc = require("./../controllers/responseController");

module.exports.add = (req, res) => {
  let newReligion = new religion({
    religion_id: req.body.religion_id,
    religion_name: req.body.religion_name,
    religion_slug: req.body.religion_slug,
    religion_added_by: req.body.religion_added_by,
    religion_is_deleted: req.body.religion_is_deleted,
    religion_order: req.body.religion_order,
    religion_created_on: req.body.religion_created_on,
    religion_status: req.body.religion_status
  });
  religion.addReligion(newReligion, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  const id = req.body._id;
  religion.getReligion(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  religion.getAllReligion((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.update = (req, res) => {
  const id = req.body._id;
  religion.getReligion(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        isChange = false;
        data.lastChanges = {};

        if (req.body.religion_name) {
          isChange = true;
          data.lastChanges.religion_name = data.religion_name;
          data.religion_name = req.body.religion_name;
        }
        if (req.body.religion_slug) {
          isChange = true;
          data.lastChanges.religion_slug = data.religion_slug;
          data.religion_slug = req.body.religion_slug;
        }

        if (req.body.religion_is_deleted) {
          isChange = true;
          data.lastChanges.religion_is_deleted = data.religion_is_deleted;
          data.religion_is_deleted = req.body.religion_is_deleted;
        }
        if (req.body.religion_order) {
          isChange = true;
          data.lastChanges.religion_order = data.religion_order;
          data.religion_order = req.body.religion_order;
        }

        if (req.body.religion_status) {
          isChange = true;
          data.lastChanges.religion_status = data.religion_status;
          data.religion_status = req.body.religion_status;
        }

        if (isChange) {
          data.religion_updated_on = Date.now();
          data.religion_updated_by = req.body.username;
          religion.addReligion(data, (err, updatedData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Data updated successfully",
                data: updatedData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No changes provided"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.params._id;
  religion.deleteReligion(id, (err, deletedData) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (deletedData) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: deletedData
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
