const io = require('../app');
const newMember = require("./../models/new_member");
const Lead = require("./../models/lead");
const Chat = require("./../models/chat");
const _ = require('lodash');

io.on('connection', socket => {
    let UserId = socket.id;
    socket.on('disconnect', function () {
        console.log(`${UserId} disconnected X-X-X-X-X-X`);
    });
    socket.on('check', msg => {
        socket.emit('reply', { msg: 'Server is running... 🏃🏻‍♂️' });
    });
    socket.on('getApproveCount', doc => {
        newMember.getUnapprovedMembers((err, members) => {
            if (err) {
                console.log(err);
            } else {
                if (members.length) {
                    socket.emit('approvecountupdate', { count: members.length });
                } else {
                    socket.emit('approvecountupdate', { count: members.length });
                }
            }
        })
    });
    socket.on('lmsChat', doc => {
        const newChat = new Chat({
            msgType: doc.msgType,
            content: doc.content,
            msgBy: doc.msgBy,
            msgFor: doc.msgFor,
            approvedStatus: 'Y',
            readStatus: 'N',
            isGroup: doc.isGroup,
            createdAt: Date.now()
        });
        Chat.addChat(newChat, (err, newDoc) => {
            if (err) {
                console.log(err);
            } else {
                if (newDoc) {
                    socket.emit('chatAdded', { newDoc });
                    Chat.getChatsByUser(newDoc.msgBy, newDoc.msgFor, 50, 0, (err, docs) => {
                        if (err) {
                            console.log(err);
                        } else {
                            if (docs.length) {
                                docs = docs.reverse();
                                socket.emit('chatFetched', { chats: docs });
                                Chat.readChatsByUser(doc.uname, doc.fname, (err, docs) => { });
                            }
                        }
                    })
                } else {
                    socket.emit('chatFailed', { newChat });
                }
            }
        })
    });
    socket.on('getChats', doc => {
        Chat.getChatsByUser(doc.uname, doc.fname, doc.limit, doc.skip, (err, docs) => {
            if (err) {
                console.log(err);
            } else {
                if (docs.length) {
                    docs = docs.reverse();
                    socket.emit('chatFetched', { chats: docs });
                    Chat.readChatsByUser(doc.uname, doc.fname, (err, docs) => { });
                }
            }
        })
    });

    socket.on('getUnreadChatsCount', doc => {
        Chat.getUnreadChatsCount(doc.uname, (err, docs) => {
            if (err) {
                console.log(err);
            } else {
                socket.emit('setUnreadChatsCount', { chats: docs });
            }
        })
    });

    socket.on('getUnreadChatsByUser', doc => {
        Chat.getUnreadChatsByUser(doc.uname, (err, docs) => {
            if (err) {
                console.log(err);
            } else {
                socket.emit('setUnreadChatsByUser', { chats: docs });
            }
        })
    });

    socket.on('getUnallotedLeadsCount', doc => {
        Lead.getUnallotedLeadsCount((err, leadCount) => {
            socket.emit('UnallotedLeadsCount', { leadCount });
        });
    });
});