const desired = require("../models/ss_desired.js");
const oldDesired = require("../models/old_desired.js");

const rc = require("./responseController");
    
module.exports.add = (req, res) => {
  let newDesired = new desired({
    desired_id: req.body.desired_id,
    desired_member_slug: req.body.desired_member_slug,
    desired_age_from: req.body.desired_age_from,
    desired_age_to: req.body.desired_age_to,
    desired_gender: req.body.desired_gender,
    desired_body_type: req.body.desired_body_type,
    desired_height_from: req.body.desired_height_from,
    desired_height_to: req.body.desired_height_to,
    desired_weight_from: req.body.desired_weight_from,
    desired_weight_to: req.body.desired_weight_to,
    desired_maritial_status: req.body.desired_maritial_status,
    desired_country: req.body.desired_country,
    desired_religion: req.body.desired_religion,
    desired_caste: req.body.desired_caste,
    desired_sub_caste: req.body.desired_sub_caste,
    desired_mother_tongue: req.body.desired_mother_tongue,
    desired_manglik: req.body.desired_manglik,
    desired_gotra: req.body.desired_gotra,
    desired_mama_gotra: req.body.desired_mama_gotra,
    desired_education: req.body.desired_education,
    desired_occupation: req.body.desired_occupation,
    desired_income: req.body.desired_income,
    desired_own_house: req.body.desired_own_house,
    desired_family_status: req.body.desired_family_status,
    desired_family_income: req.body.desired_family_income,
    desired_family_type: req.body.desired_family_type,
    desired_family_value: req.body.desired_family_value,
    desired_family_residential_status: req.body.desired_family_residential_status,
    desired_eating_habit: req.body.desired_eating_habit,
    desired_drinking_habit: req.body.desired_drinking_habit,
    desired_smoking_habit: req.body.desired_smoking_habit,
    desired_complexion: req.body.desired_complexion,
    desired_abled: req.body.desired_abled,
    desired_abled_details: req.body.desired_abled_details,
    desired_about_partner: req.body.desired_about_partner,
    desired_is_deleted: req.body.desired_is_deleted,
    desired_created_on:Date.now(),
    desired_member_id: req.body.desired_member_id,
    desired_user_id: req.body.desired_user_id,
    desired_status: req.body.desired_status,
  });
  desired.addDesired(newDesired, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  const id = req.body._id;
  desired.getDesired(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getByMemberId = (req, res) => {
  const id = req.body._id;
  desired.getByMemberId(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  desired.getAllDesired((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.addProjectedMembers = (req, res) => {
  res.json({ msg: "started" });
  console.log("started...");
  console.log("getting desired with projection...");
  oldDesired.getDesiredWithProjection((err, data) => {
    console.log("desired fetched with projection...");
    if (err) throw err;
    else {
      console.log("data recieved...");
      if (data.length) {
        desired.insertMany(data, (err, data1) => {
          if (err) throw err;
          else {
            console.log("added");
          }
        });
      }
    }
  });
};

// module.exports.addProjectedMembers = (req, res) =>{
//   oldDesired.getDesiredWithProjection((err,data)=>{
//     if(err){
//       rc.setResponse(res, {
//         msg: err.message,
//         data: err
//       });
//     }else{
//       if(data){
//         console.log('members fetched now inserting');
//         desired.insertMany(data,(err,data)=>{
//           if(err){
//             rc.setResponse(res,{
//               msg: "Error in inserting data"
//             })
//           }else{
//             rc.setResponse(res,{
//               success: true,
//               msg: "All data inserted successfully"
//             })
//           }
//         })
//       }
//     }
//   })
// }
module.exports.getWithProj = (req, res) => {
  oldDesired.getDesiredWithProjection((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        

        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};


module.exports.update = (req, res) => {
  const id = req.body._id;
  console.log(req.body.isOld);
  desired.getDesired(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        isChange = false;
        data.lastChanges = {};
        
        if(req.body.desired_member_slug){
            data.desired_member_slug = req.body.desired_member_slug,
            isChange = true;
        }
        if(req.body.desired_age_from){
            data.desired_age_from = req.body.desired_age_from;
            isChange = true;

        }
        if(req.body.desired_age_to){
            data.desired_age_to = req.body.desired_age_to;
            isChange = true;

        }
        if(req.body.desired_gender){
            data.desired_gender = req.body.desired_gender;
            isChange = true;

        }
        if(req.body.desired_body_type){
            data.desired_body_type = req.body.desired_body_type;
            isChange = true;

        }
        if(req.body.desired_height_from){
            data.desired_height_from = req.body.desired_height_from;
            isChange = true;

        }
        if(req.body.desired_height_to){
            data.desired_height_to = req.body.desired_height_to;
            isChange = true;

        }
        if(req.body.desired_weight_from){
            data.desired_weight_from = req.body.desired_weight_from;
            isChange = true;

        }
        if(req.body.desired_weight_to){
            data.desired_weight_to = req.body.desired_weight_to;
            isChange = true;

        }
        if(req.body.desired_maritial_status){
            data.desired_maritial_status = req.body.desired_maritial_status;
            isChange = true;

        }
        if(req.body.desired_country){
            data.desired_country = req.body.desired_country;
            isChange = true;

        }
        if(req.body.desired_religion){
            data.desired_religion = req.body.desired_religion;
            isChange = true;

        }
        if(req.body.desired_caste){
            data.desired_caste = req.body.desired_caste;
            isChange = true;

        }
        if(req.body.desired_sub_caste){
            data.desired_sub_caste = req.body.desired_sub_caste;
            isChange = true;

        }
        if(req.body.desired_mother_tongue){
            data.desired_mother_tongue = req.body.desired_mother_tongue;
            isChange = true;

        }
        if(req.body.desired_manglik){
            data.desired_manglik = req.body.desired_manglik;
            isChange = true;

        }
        if(req.body.desired_gotra){
            data.desired_gotra = req.body.desired_gotra;
            isChange = true;

        }
        if(req.body.desired_mama_gotra){
            data.desired_mama_gotra = req.body.desired_mama_gotra;
            isChange = true;

        }
        if(req.body.desired_education){
            data.desired_education = req.body.desired_education;
            isChange = true;

        }
        if(req.body.desired_occupation){
            data.desired_occupation = req.body.desired_occupation;
            isChange = true;

        }
        if(req.body.desired_income){
            data.desired_income = req.body.desired_income;
            isChange = true;

        }
        if(req.body.desired_own_house){
            data.desired_own_house = req.body.desired_own_house;
            isChange = true;

        }
        if(req.body.desired_family_status){
            data.desired_family_status = req.body.desired_family_status;
            isChange = true;

        }
        if(req.body.desired_family_income){
            data.desired_family_income = req.body.desired_family_income;
            isChange = true;

        }
        if(req.body.desired_family_type){
            data.desired_family_type = req.body.desired_family_type;
            isChange = true;

        }
        if(req.body.desired_family_value){
            data.desired_family_value = req.body.desired_family_value;
            isChange = true;

        }
        if(req.body.desired_family_residential_status){
            data.desired_family_residential_status = req.body.desired_family_residential_status;
            isChange = true;

        }
        if(req.body.desired_eating_habit){
            data.desired_eating_habit = req.body.desired_eating_habit;
            isChange = true;

        }
        if(req.body.desired_drinking_habit){
            data.desired_drinking_habit = req.body.desired_drinking_habit;
            isChange = true;

        }
        if(req.body.desired_smoking_habit){
            data.desired_smoking_habit = req.body.desired_smoking_habit;
            isChange = true;

        }
        if(req.body.desired_complexion){
            data.desired_complexion = req.body.desired_complexion;
            isChange = true;

        }
        if(req.body.desired_abled){
            data.desired_abled = req.body.desired_abled;
            isChange = true;

        }
        if(req.body.desired_abled_details){
            data.desired_abled_details = req.body.desired_abled_details;
            isChange = true;

        }
        if(req.body.desired_about_partner){
            data.desired_about_partner = req.body.desired_about_partner;
            isChange = true;

        }
        if(req.body.desired_is_deleted){
            data.desired_is_deleted = req.body.desired_is_deleted;
            isChange = true;

        }
        
        if(req.body.desired_member_id){
            data.desired_member_id = req.body.desired_member_id;
            isChange = true;

        }
        if(req.body.desired_user_id){
            data.desired_user_id = req.body.desired_user_id;
            isChange = true;

        }
        if(req.body.desired_status){
            data.desired_status = req.body.desired_status;
            isChange = true;

        }

        if (isChange) {
          
          desired.addDesired(data, (err, updatedData) => {
            if (err) {
              rc.setResponse(res, {
                msg: err.message,
                data: err
              });
            } else {
              rc.setResponse(res, {
                success: true,
                msg: "Data updated successfully",
                data: updatedData
              });
            }
          });
        } else {
          rc.setResponse(res, {
            msg: "No changes provided"
          });
        }
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};

module.exports.delete = (req, res) => {
  const id = req.body._id;
  desired.deleteDesired(id, (err, deletedData) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (deletedData) {
        rc.setResponse(res, {
          success: true,
          msg: "Data deleted successfully",
          data: deletedData
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id "
        });
      }
    }
  });
};
