const state = require("./../models/state1.js");
const rc = require("./../controllers/responseController");

module.exports.add = (req, res) => {
  let newState = new state({
    state_id: req.body.state_id,
    state_name: req.body.state_name,
    state_slug: req.body.state_slug,
    state_code: req.body.state_code,
    state_country_id: req.body.state_country_id,
    state_order: req.body.state_order,
    state_is_deleted: req.body.state_is_deleted,
    state_created_on: req.body.state_created_on,
    state_status: req.body.state_status
  });
  state.addState(newState, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      rc.setResponse(res, {
        success: true,
        msg: "Data added successfully",
        data: data
      });
    }
  });
};

module.exports.get = (req, res) => {
  const id = req.body._id;
  state.getState(id, (err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found by this id"
        });
      }
    }
  });
};
module.exports.getAll = (req, res) => {
  state.getAllState((err, data) => {
    if (err) {
      rc.setResponse(res, {
        msg: err.message,
        data: err
      });
    } else {
      if (data) {
        rc.setResponse(res, {
          success: true,
          msg: "Data fetched successfully",
          data: data
        });
      } else {
        rc.setResponse(res, {
          msg: "No data found "
        });
      }
    }
  });
};

module.exports.update = (req, res)=>{
    const id = req.body._id;
    state.getState(id, (err, data)=>{
        if(err){
            rc.setResponse(res, {
                msg: err.message,
                data: err
              });
        }else{
            if(data){
                isChange= false;
                data.lastChanges = {};
                if(req.body.state_name){
                    isChange = true;
                    data.lastChanges.state_name = data.state_name;
                    data.state_name = req.body.state_name; 
                }
                if(req.body.state_slug){
                    isChange = true;
                    data.lastChanges.state_slug = data.state_slug;
                    data.state_slug = req.body.state_slug;
                }
                if(req.body.state_code){
                    isChange = true;
                    data.lastChanges.state_code = data.state_code;
                    data.state_code = req.body.state_code;
                }
                if(req.body.state_country_id){
                    isChange = true;
                    data.lastChanges.state_country_id = data.state_country_id;
                    data.state_country_id = req.body.state_country_id;
                }
                if(req.body.state_order){
                    isChange = true;
                    data.lastChanges.state_order = data.state_order;
                    data.state_order = req.body.state_order;
                }
                if(req.body.state_is_deleted){
                    isChange = true;
                    data.lastChanges.state_is_deleted = data.state_is_deleted;
                    data.state_is_deleted = req.body.state_is_deleted;
                }
                if(req.body.state_created_on){
                    isChange = true;
                    data.lastChanges.state_created_on = data.state_created_on;
                    data.state_created_on = req.body.state_created_on;
                }
                if(req.body.state_status){
                    isChange = true;
                    data.lastChanges.state_status = data.state_status;
                    data.state_status = req.body.state_status;
                }

                if(isChange){
                    data.state_updated_on =Date.now();
                    data.state_updated_by = req.body.username;
                    state.addState(data, (err, updatedData)=>{
                        if (err) {
                            rc.setResponse(res, {
                              msg: err.message,
                              data: err
                            });
                          } else {
                            rc.setResponse(res, {
                              success: true,
                              msg: "Data updated successfully",
                              data: updatedData
                            });
                          }

                    })


                }else{
                    rc.setResponse(res, {
                        msg: "No changes provided"
                      });
                }

            }else{
                rc.setResponse(res, {
                    msg: "No data found by this id "
                  });
            }
        }
    })
}

module.exports.delete = (req, res)=>{
    const id = req.body._id;
    state.deleteState(id, (err, deletedData)=>{
        if(err){
            rc.setResponse(res, {
                msg: err.message,
                data: err
              });
        }else{
            if(deletedData){
                rc.setResponse(res, {
                    success: true,
                    msg: "Data deleted successfully",
                    data: deletedData
                  });
            }else{
                rc.setResponse(res, {
                    msg: "No data found by this id "
                  });
            }
        }
    })
}

