const config = require("../config/database");
const mongoose = require("mongoose");

const casteSchema = mongoose.Schema(
  {
    caste_id: {
      type: String,
      default: ""
    },
    caste_name: {
      type: String,
      default: ""
    },
    caste_slug: {
      type: String,
      default: ""
    },
    caste_parent: {
      type: String,
      default: ""
    },
    caste_added_by: {
      type: String,
      default: ""
    },
    caste_updated_by: {
      type: String,
      default: ""
    },
    caste_is_deleted: {
      type: String,
      default: ""
    },
    caste_created_on: {
      type: Date,
      default: Date.now()
    },
    caste_updated_on: {
      type: Date,
    },
    caste_order: {
      type: String,
      default: ""
    },
    caste_status: {
      type: String,
      default: ""
    },
    caste_religion_name: {
      type: String,
      default: ""
    },

    lastChanges: {
      type: JSON,
      default: {}
    }
  },
  { collection: "sbw_castes" }
);

const caste = (module.exports = mongoose.model("sbw_castes", casteSchema));

// Create and update
module.exports.addCaste = (newCaste, callback) => {
  newCaste.save(callback);
};

// get caste
module.exports.getCaste = (id, callback) => {
  caste.findById(id, callback);
};
module.exports.getDesiredCaste = (id, callback) => {
  caste.find({caste_id:{$in: id}}, callback);
};


// get all castes
module.exports.getAllCaste = callback => {
  caste.find( callback);
};
// get all caste names
module.exports.getAllCasteNames = callback => {
  caste.find( null,{"caste_name": true, caste_id: true}, callback);
};

//delete caste
module.exports.deleteCaste = (id, callback) => {
  caste.findByIdAndDelete(id, callback);
};


