const mongoose = require('mongoose');
const config = require('../config/database');

const citySchema = mongoose.Schema({
  view: { type: String, required: true },
  name: { type: String, required: true },
  state: { type: String, required: true },
  country: { type: String, required: true },
  district: { type: String, required: true },
  createdBy: { type: String },
  createdAt: { type: Date, default: Date.now() }
});

const City = (module.exports = mongoose.model('city', citySchema));

module.exports.addNewCity = (newCity, callback) => {
  newCity.save(callback);
};

module.exports.getCityByName = (cityname, callback) => {
  City.findOne({ name: cityname }, callback);
};

module.exports.getCityByState = (stateName, callback) => {
  City.find({ state: stateName }, callback);
}

module.exports.getCitiesByDistrict = (dist, callback) => {
  City.find({ district: dist }, callback);
}



module.exports.getCities = callback => {
  City.find(callback);
};
