const mongoose = require("mongoose");
const config = require("./../config/database");

const countrySchema = mongoose.Schema({
  country_id: {
    type: String,
    default: ""
  },
  country_name: {
    type: String,
    default: ""
  },
  country_currency_code: {
    type: String,
    default: ""
  },
  country_isd_code: {
    type: String,
    default: ""
  },
  country_flag: {
    type: String,
    default: ""
  },
  country_order: {
    type: String,
    default: ""
  },
  country_added_by: {
    type: String,
    default: ""
  },
  country_is_deleted: {
    type: String,
    default: ""
  },
  country_created_on: {
    type: Date,
    default: Date.now()
  },
  country_updated_by: {
    type: String,
    default: ""
  },
  country_updated_on: {
    type: Date,
    default: ""
  },

  country_status: {
    type: String,
    default: ""
  },
  lastChanges: {
    type: JSON,
    default: {}
  }
},{collection: 'sbw_countries'});

const country = (module.exports= mongoose.model('sbw_countries', countrySchema ));
// Create and update
module.exports.addCountry = (newCountry, callback) => {
    newCountry.save(callback);
  };
  // Get by id
  module.exports.getCountry = (id, callback) => {
    country.findById(id, callback);
  };
  module.exports.getDesiredCountry = (id, callback) =>{
    country.find({country_id: {$in: id}}, callback);
  }
  //Get all countries
  module.exports.getAllCountry = callback => {
    country.find(callback);
  };
  
  //Delete by id
  module.exports.deleteCountry = (id, callback) => {
    country.findByIdAndDelete(id, callback);
  };
