const mongoose = require('mongoose');
const config = require('../config/database');

const familyStatusSchema = mongoose.Schema({
    family_status_id: { type: String, required: true },
    family_status_title: { type: String, required: true },
    family_status_is_deleted: { type: Boolean,  },
    family_status_added_by: { type: String },
    family_status_order: { type: String },
    family_status_status: { type: String },
    family_status_created_on: { type: Date, default: Date.now() }
}, { collection: 'sbw_family_status'});

const FamilyStatus = (module.exports = mongoose.model('sbw_family_status', familyStatusSchema));

// Add familyStatus
module.exports.addFamilyStatus = (familyStatus, callback) => {
	FamilyStatus.create(familyStatus, callback);
}

// read familyStatus
module.exports.getFamilyStatus = (callback) => {
	FamilyStatus.find(callback);
}
module.exports.getDesiredFamilyStatus = (id, callback) => {
	FamilyStatus.find({family_status_id: {$in: id}},callback);
}

//find a familyStatus by id
module.exports.getFamilyStatusById=(Id,callback)=>{
  FamilyStatus.findOne({"family_status_id":Id},callback);
}

//find a familyStatus by title
module.exports.getFamilyStatusByTitle=(title,callback)=>{
  FamilyStatus.findOne({"family_status_title":title},callback);
}


// Update familyStatus
module.exports.updateFamilyStatus = (id, familyStatus, options, callback) => {
	var query = {family_status_id: id};
  var update = {};
  if(familyStatus.family_status_title){
    update.family_status_title= familyStatus.family_status_title

  }
  if(familyStatus.family_status_is_deleted){
    update.family_status_is_deleted= familyStatus.family_status_is_deleted

  }
  if(familyStatus.family_status_added_by){
    update.family_status_added_by= familyStatus.family_status_added_by

  }
  if(familyStatus.family_status_order){
    update.family_status_order= familyStatus.family_status_order

  }
  if(familyStatus.family_status_status){
    update.family_status_status= familyStatus.family_status_status

  }
        
	FamilyStatus.findOneAndUpdate(query, update, options, callback);
}


// Delete FamilyStatus
module.exports.removeFamilyStatus = (id, callback) => {
	var query = {family_status_id: id};
	FamilyStatus.remove(query, callback);
}


