const mongoose = require('mongoose');
const config = require('../config/database');

const familyValueSchema = mongoose.Schema({
    family_value_id: { type: String, required: true },
    family_value_title: { type: String, required: true },
    family_value_slug: { type: String },
    family_value_is_deleted: { type: Boolean,  },
    family_value_added_by: { type: String },
    family_value_order: { type: String },
    family_value_status: { type: String },
    family_value_created_on: { type: Date, default: Date.now() }
}, { collection: 'sbw_family_values'});

const FamilyValue = (module.exports = mongoose.model('sbw_family_values', familyValueSchema));

// Add familyValue
module.exports.addFamilyValue = (familyValue, callback) => {
	FamilyValue.create(familyValue, callback);
}

// read familyValue
module.exports.getFamilyValue = (callback) => {
	FamilyValue.find(callback);
}
module.exports.getDesiredFamilyValue = (id,callback) => {
	FamilyValue.find({family_value_id: {$in: id}}, callback);
}

//find a familyValue by id
module.exports.getFamilyValueById=(Id,callback)=>{
  FamilyValue.findOne({"family_value_id":Id},callback);
}

//find a familyValue by title
module.exports.getFamilyValueByTitle=(title,callback)=>{
  FamilyValue.findOne({"family_value_title":title},callback);
}


// Update familyValue
module.exports.updateFamilyValue = (id, familyValue, options, callback) => {
	var query = {family_value_id: id};
	var update = {
        family_value_title: familyValue.family_value_title,
        family_value_slug: familyValue.family_value_slug,
        family_value_is_deleted: familyValue.family_value_is_deleted,
        family_value_added_by: familyValue.family_value_added_by,
        family_value_order: familyValue.family_value_order,
        family_value_status: familyValue.family_value_status,
    }
	FamilyValue.findOneAndUpdate(query, update, options, callback);
}


// Delete FamilyValue
module.exports.removeFamilyValue = (id, callback) => {
	var query = {family_value_id: id};
	FamilyValue.remove(query, callback);
}


