const mongoose = require('mongoose');
const config = require('../config/database');

const FollowUpTypeSchema = mongoose.Schema({
  followUpType: String,
  label: String,
  priority: Number,
  oldNames: String,
  count: {
    type: Number,
    default: 0
  },
  icon: String,
  hasDueDate: String,
  canDelete: { type: Boolean, default: true },
  createdBy: { type: String },
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedAt: { type: Date }
});

const FollowUpType = (module.exports = mongoose.model(
  'followUpType',
  FollowUpTypeSchema
));

module.exports.addFollowUpType = (newFollowUpType, callback) => {
  newFollowUpType.save(callback);
};

module.exports.getFollowUpTypeByName = (followUpType, callback) => {
  FollowUpType.findOne({ followUpType: followUpType }, callback);
};

module.exports.getFollowUpTypes = callback => {
  FollowUpType.find(callback);
};

module.exports.deleteFollowUpType = (followuptype, callback) => {
  FollowUpType.deleteOne({ followUpType: followuptype }, callback);
};


/**
 * from: The target collection.
 * localField: The local join field.
 * foreignField: The target join field.
 * as: The name for the results.
 * pipeline: The pipeline to run on the joined collection.
 * let: Optional variables to use in the pipeline field stages.
 */
// {
//   from: 'leads',
//     pipeline: [
//       {
//         $addFields: {
//           "lastStatus": { $arrayElemAt: ["$followup.status", -1] }
//         },
//       },
//       {
//         $match: {
//           "lastStatus": { $in: ["PROSPECT", "PROSPECT / QUOTE"] }
//         }
//       }
//     ],
//       as: 'leads'
// }

/**
 * newField: The new field name.
 * expression: The new field expression.
 */
// {
//   "leadsSize": {
//     $cond: { if: { $isArray: "$leads" }, then: { $size: "$leads" }, else: "NA" }
//   }
// }

/**
 * specifications: The fields to
 *   include or exclude.
 */
// {
//   leads: 0
// }