const mongoose = require('mongoose');
const config = require('../config/database');

const FollowupLogSchema = mongoose.Schema({
    followupby: { type: String, required: true },
    followupof: { type: JSON, required: true },
    followuptype: { type: String, required: true },
    remark: { type: String },
    createdAt: {
        type: Date,
        default: Date.now()
    },
});

const FollowupLog = (module.exports = mongoose.model("followuplog", FollowupLogSchema));

module.exports.addLog = (newLog, callback) => {
    newLog.save(callback);
};

module.exports.getLogById = (id, callback) => {
    FollowupLog.findOne({ _id: id }, callback);
}

module.exports.getFollowupByCaller = (callerName, callback) => {
    FollowupLog.find({ followupby: callerName }, callback);
}

module.exports.getFollowupof = (followupof, callback) => {
    FollowupLog.findOne({ followupof: followupof }, callback);
};

module.exports.getAllFollowups = (callback) => {
    FollowupLog.find(callback);
};