const mongoose = require('mongoose');
const config = require('../config/database');

const NewLeadSchema = mongoose.Schema({
  purpose: { type: String },
  source: { type: String },
  DOB: { type: Date },
  name: { type: String },
  callerId: { type: String },
  city: { type: String },
  pcity: { type: Array, default: [] },
  state: { type: String },
  country: { type: String },
  followup: { type: Array, default: [] },
  messages: { type: Array, default: [] },
  email: { type: String },
  state: { type: String },
  gender: { type: String },
  mobile: { type: String },
  wanumber: { type: String },
  sendAddress: { type: Array, default: [] },
  createdBy: { type: String },
  counsellor: { type: JSON },
  package: { type: String },
  allotedTo: { type: String, default: 'none' },
  occupation: { type: String },
  rpay: { type: String },
  privilegeDiscount: { type: String },
  coupenSeries: { type: String },
  coupenNumber: {type: String},
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedAt: { type: Date, default: Date.now() },
  updatedBy: { type: String }
});

const Lead = (module.exports = mongoose.model('lead', NewLeadSchema));

module.exports.addNewLead = (newLead, callback) => {
  newLead.save(callback);
};

module.exports.getLeadById = (id, callback) => {
  Lead.findOne({ _id: id }, callback);
};

module.exports.deleteLeadById = (id, callback) => {
  Lead.deleteOne({ _id: id }, callback);
};

module.exports.getNewLeads = callback => {
  Lead.find({ followup: { $eq: [] } }, callback);
};

module.exports.getOldLeads = callback => {
  Lead.find({ followup: { $ne: [] } }, callback);
};

module.exports.getLeads = callback => {
  Lead.find(callback);
};

module.exports.getNewLeadsByUser = (username, callback) => {
  Lead.find({ allotedTo: username, followup: { $eq: [] } }, callback);
};

module.exports.getOldLeadsByUser = (username, callback) => {
  Lead.find({ allotedTo: username, followup: { $ne: [] } }, callback);
};

module.exports.getLeadsByUser = (username, callback) => {
  Lead.find({ allotedTo: username }, callback);
};

// testing inserting array using insert command
module.exports.insertArrayofLeads = (leads, callback) => {
  Lead.insertMany(leads, callback);
};
