const mongoose = require('mongoose');
const config = require('../config/database');

const MemberTypeSchema = mongoose.Schema({
  memberType: String,
  createdBy: { type: String },
  createdAt: {
    type: Date,
    default: Date.now()
  },
  updatedAt: { type: Date }
});

const MemberType = (module.exports = mongoose.model(
  'MemberType',
  MemberTypeSchema
));

module.exports.addMemberType = (newMember, callback) => {
  newMember.save(callback);
};

module.exports.getMemberByType = (memberType, callback) => {
  MemberType.findOne({ memberType: memberType }, callback);
};

module.exports.getMember = callback => {
  MemberType.find(callback);
};

module.exports.deleteMemberType = (memberType, callback) => {
  MemberType.deleteOne({ memberType: memberType }, callback);
};
