

const mongoose = require("mongoose");
const config = require("./../config/database");

const mother_tongueSchema = mongoose.Schema(
  {
    mother_tongue_id: {
      type: String,
      default: ""
    },
    mother_tongue_name: {
      type: String,
      default: ""
    },
    mother_tongue_slug: {
      type: String,
      default: ""
    },
    mother_tongue_added_by: {
      type: String,
      default: ""
    },
    mother_tongue_updated_by: {
      type: String,
      default: ""
    },
    mother_tongue_is_deleted: {
      type: String,
      default: ""
    },
    mother_tongue_created_on: {
      type: String,
      default: ""
    },
    mother_tongue_updated_on: {
      type: String,
      default: ""
    },
    mother_tongue_order: {
      type: String,
      default: ""
    },
    mother_tongue_status: {
      type: String,
      default: ""
    },
    lastChanges: {
      type: JSON,
      default: {}
    }
  },
  { collection: "sbw_mother_tongues" }
);

const mother_tongue = (module.exports = mongoose.model(
  "sbw_mother_tongues",
  mother_tongueSchema
));

//Create and update
module.exports.addMother_tongue = (newMother_tongue, callback) => {
  newMother_tongue.save(callback);
};

// Get mother_tongue by id
module.exports.getMother_tongue = (id, callback) => {
  mother_tongue.findById(id, callback);
};

// Get all the mother_tongues
module.exports.getAllMother_tongue = callback => {
  mother_tongue.find(callback);
};
module.exports.getDesiredMother_tongue = (id, callback) => {
  mother_tongue.find({mother_tongue_id: {$in: id}},callback);
};
// Get all the mother_tongues names
module.exports.getAllMother_tongueNames = callback => {
  mother_tongue.find(null ,{"mother_tongue_name": true, "mother_tongue_id": true }, callback);
};

// Delete a mother_tongue
module.exports.deleteMother_tongue = (id, callback) => {
  mother_tongue.findByIdAndDelete(id, callback);
};
