const mongoose = require("mongoose");
const config = require("./../config/database");
const bcrypt = require("bcryptjs");

const memberSchema = mongoose.Schema(
  {
    member_id: {
      type: String,
      default: ""
    },
    member_citydummy: {
      type: String,
      default: ""
    },
    member_occupationdummy: {
      type: String,
      default: ""
    },
    member_lead_id: {
      type: String,
      default: ""
    },
    member_profile_created_for: {
      type: String,
      default: ""
    },
    member_first_name: {
      type: String,
      default: ""
    },
    member_middle_name: {
      type: String,
      default: ""
    },
    member_last_name: {
      type: String,
      default: ""
    },
    member_name: {
      type: String,
      trim: true,
      default: "",
      index: true
    },
    member_is_updated: {
      type: String,
      default: ""
    },
    member_slug: {
      type: String,
      default: ""
    },
    member_mobile: {
      type: String,
      default: "On Request"
    },
    member_email: {
      type: String,
      default: "On Request"
    },
    member_religion_name: {
      type: String,
      default: "On Request"
    },
    member_caste_name: {
      type: String,
      default: "On Request"
    },
    member_sub_caste_name: {
      type: String,
      default: "On Request"
    },
    member_gender: {
      type: String,
      default: ""
    },
    member_dob: {
      type: String,
      default: ""
    },
    member_weight: {
      type: String,
      default: ""
    },
    member_height: {
      type: String,
      default: ""
    },
    member_complextion: {
      type: String,
      default: ""
    },
    member_meritial_status: {
      type: String,
      default: ""
    },
    member_children_status: {
      type: String,
      default: ""
    },
    member_total_children: {
      type: String,
      default: ""
    },
    member_age_eldest_children: {
      type: String,
      default: ""
    },
    member_eating_habits: {
      type: String,
      default: ""
    },
    member_drinking_habits: {
      type: String,
      default: ""
    },
    member_smoking_habits: {
      type: String,
      default: ""
    },
    member_hobby: {
      type: String,
      default: ""
    },
    member_body_type: {
      type: String,
      default: ""
    },
    member_special_case: {
      type: String,
      default: ""
    },
    member_special_case_details: {
      type: String,
      default: ""
    },
    member_residencial_status: {
      type: String,
      default: ""
    },
    member_mother_tongue: {
      type: String,
      default: ""
    },
    member_own_house_status: {
      type: String,
      default: ""
    },
    member_annual_income: {
      type: String,
      default: ""
    },
    member_education_details: {
      type: String,
      default: ""
    },
    member_collage_passout: {
      type: String,
      default: ""
    },
    member_professional_status: {
      type: String,
      default: "On Request"
    },
    member_professional_details: {
      type: String,
      default: "On Request"
    },
    member_working_location: {
      type: String,
      default: ""
    },
    member_visa_status: {
      type: String,
      default: ""
    },
    member_father_name: {
      type: String,
      default: ""
    },
    member_father_occupation: {
      type: String,
      default: ""
    },
    member_father_occupation_details: {
      type: String,
      default: ""
    },
    member_mother_name: {
      type: String,
      default: ""
    },
    member_mother_occupation: {
      type: String,
      default: ""
    },
    member_mother_occupation_details: {
      type: String,
      default: ""
    },
    member_family_status: {
      type: String,
      default: ""
    },
    member_family_income: {
      type: String,
      default: ""
    },
    member_family_type: {
      type: String,
      default: ""
    },
    member_family_values: {
      type: String,
      default: ""
    },
    member_relatives_details: {
      type: String,
      default: ""
    },
    member_gotra: {
      type: String,
      default: ""
    },
    member_mama_gotra: {
      type: String,
      default: ""
    },
    member_rashi: {
      type: String,
      default: ""
    },
    member_tob: {
      type: String,
      default: ""
    },
    member_place_of_birth: {
      type: String,
      default: ""
    },
    member_manglik: {
      type: String,
      default: ""
    },
    member_horoscope_match: {
      type: String,
      default: ""
    },
    member_horoscope_file: {
      type: String,
      default: ""
    },
    member_namaj_offered: {
      type: String,
      default: ""
    },
    member_have_bread: {
      type: String,
      default: ""
    },
    member_face_covering_girl: {
      type: String,
      default: ""
    },
    member_jain_day_routine: {
      type: String,
      default: ""
    },
    member_jain_religion_studies: {
      type: String,
      default: ""
    },
    member_jatadhari_amritdhari_pagdi_sardar: {
      type: String,
      default: ""
    },
    member_sahajdhari_sardar: {
      type: String,
      default: ""
    },
    member_kripan_dhari: {
      type: String,
      default: ""
    },
    member_image: {
      type: String,
      default: ""
    },
    member_image2: {
      type: String,
      default: ""
    },
    member_image3: {
      type: String,
      default: ""
    },
    member_image4: {
      type: String,
      default: ""
    },
    member_family_photo: {
      type: String,
      default: ""
    },
    member_image_with_aadhar: {
      type: String,
      default: ""
    },
    member_id_card_image: {
      type: String,
      default: ""
    },
    member_password: {
      type: String,
      default: ""
    },
    member_hash_password: {
      type: String,
      default: ""
    },
    member_country_id: {
      type: String,
      default: ""
    },
    member_state_id: {
      type: String,
      default: ""
    },
    member_city_id: {
      type: String,
      default: ""
    },
    member_city: {
      type: String,
      default: ""
    },
    member_pincode: {
      type: String,
      default: ""
    },
    member_address: {
      type: String,
      default: ""
    },
    member_p_country_id: {
      type: String,
      default: ""
    },
    member_p_state_id: {
      type: String,
      default: ""
    },
    member_p_city_id: {
      type: String,
      default: ""
    },
    member_p_pincode: {
      type: String,
      default: ""
    },
    member_p_address: {
      type: String,
      default: ""
    },
    member_order: {
      type: String,
      default: ""
    },
    member_added_by: {
      type: String,
      default: ""
    },
    member_updated_by: {
      type: String,
      default: ""
    },
    member_created_by: {
      type: String,
      default: ""
    },
    meber_deleted_by: {
      type: String,
      default: ""
    },
    member_is_deleted: {
      type: String,
      default: ""
    },
    member_plan_id: {
      type: String,
      default: ""
    },
    member_created_on: {
      type: String,
      index: true
    },
    member_updated_on: {
      type: String,
      default: ""
    },
    member_mobile_verify: {
      type: String,
      default: ""
    },
    member_email_verify: {
      type: String,
      default: "N"
    },
    member_is_verified: {
      type: String,
      default: ""
    },
    member_details_verified_by_admin: {
      type: String,
      default: "N"
    },
    member_photo_verified: {
      type: String,
      default: ""
    },
    member_is_premium: {
      type: String,
      default: ""
    },
    member_is_online: {
      type: String,
      default: ""
    },
    member_step_completed: {
      type: String,
      default: ""
    },
    member_franchise_access: {
      type: String,
      default: ""
    },
    member_have_bpl: {
      type: String,
      default: ""
    },
    member_is_paid: {
      type: String,
      default: ""
    },
    member_is_trusted: {
      type: String,
      default: ""
    },
    member_profile_visibility: {
      type: String,
      default: ""
    },
    member_profile_access_by: {
      type: String,
      default: ""
    },
    member_is_investigated: {
      type: String,
      default: ""
    },
    member_about: {
      type: String,
      default: ""
    },
    member_staff: {
      type: String,
      default: ""
    },
    member_status: {
      type: String,
      default: ""
    },
    member_last_login: {
      type: String,
      default: ""
    },
    member_view_member_limit: {
      type: String,
      default: ""
    },
    member_is_visible: {
      type: String,
      default: ""
    },
    member_is_approved: {
      type: String,
      default: "Y"
    },
    member_reports: {
      type: String,
      default: ""
    },
    subscribed_events: {
      type: Array,
      default: []
    },
    subscribed_books: {
      type: Array,
      default: []
    },
    wallet: {
      type: String,
      default: "0"
    },
    last_transaction_id: {
      type: String
    },
    dupIds: {
      type: JSON
    },
    dupCount: {
      type: String,
      default: ""
    },
    lastChanges: {
      type: JSON
    },
    newChanges: {
      type: JSON
    },
    member_district: {
      type: String,
      default: ""
    },
    member_whatsapp_mobile: {
      type: String,
      default: ""
    },
    member_bandhan: {
      type: String,
      default: ""
    },
    member_married_brothers: {
      type: String,
      default: ""
    },
    member_unmarried_brothers: {
      type: String,
      default: ""
    },
    member_married_sisters: {
      type: String,
      default: ""
    },
    member_unmarried_sisters: {
      type: String,
      default: ""
    },
    member_partner_name: {
      type: String,
      default: ""
    },
    member_father_in_law_name: {
      type: String,
      default: ""
    },
    member_father_in_law_address: {
      type: String,
      default: ""
    },
    member_sons: {
      type: String,
      default: ""
    },
    member_eldest_son_daughter: {
      type: String,
      default: ""
    },
    member_daughters: {
      type: String,
      default: ""
    },
    member_relative1_name: {
      type: String,
      default: ""
    },
    member_relative1_number: {
      type: String,
      default: ""
    },
    member_relative2_name: {
      type: String,
      default: ""
    },
    member_relative2_number: {
      type: String,
      default: ""
    },
    member_relative3_name: {
      type: String,
      default: ""
    },
    member_relative3_number: {
      type: String,
      default: ""
    }
  },
  { collection: "sbw_current_members" }
);

memberSchema.index({ _id: 1, member_created_on: 1, member_name: 1 });

const NewMember = (module.exports = mongoose.model(
  "sbw_current_members",
  memberSchema
));

NewMember.createIndexes();

//Create and update
module.exports.addNewMember = (newMember, callback) => {
  newMember.save(callback);
};
//Get all the new members

module.exports.getAllMembers = (sort, skip, callback) => {
  NewMember.find({ member_mobile: { $exists: true } }, callback)
    .skip(skip)
    .limit(20)
    .sort(sort);
};
// Get member by _id
module.exports.getMember = (id, callback) => {
  NewMember.findById(id, callback);
};

module.exports.updateWallet = (
  id,
  transAmount,
  last_transaction_id,
  callback
) => {
  NewMember.findById(id, (err, mem) => {
    // console.log(id);
    if (err) {
      callback(err, null);
    } else {
      if (mem) {
        // console.log(parseInt(mem.wallet), transAmount);
        let newAmount = parseInt(mem.wallet) + transAmount;
        NewMember.updateOne(
          { _id: id },
          { $set: { wallet: newAmount, last_transaction_id } },
          callback
        );
      } else {
        const error = {
          message: "no member found by this id"
        };
        callback(err, null);
      }
    }
  });
};

module.exports.getMemInEvent = (event, callback) => {
  // NewMember.find({ subscribed_events: { $in: event } }, callback);
  NewMember.aggregate(
    [
      {
        $match: {
          subscribed_events: {
            $in: [event]
          }
        }
      },
      {
        $lookup: {
          from: "sbw_desired",
          localField: "member_id",
          foreignField: "desired_member_id",
          as: "desired"
        }
      },
      // {
      //   $limit: 50
      // },
      {
        $project: {
          desired: 1,
          member_id: 1,
          member_occupationdummy: 1,
          member_profile_created_for: 1,
          member_name: 1,
          member_mobile: 1,
          member_email: 1,
          member_religion_name: 1,
          member_caste_name: 1,
          member_sub_caste_name: 1,
          member_gender: 1,
          member_dob: 1,
          member_weight: 1,
          member_height: 1,
          member_complextion: 1,
          member_meritial_status: 1,
          member_hobby: 1,
          member_body_type: 1,
          member_special_case: 1,
          member_special_case_details: 1,
          member_residencial_status: 1,
          member_mother_tongue: 1,
          member_own_house_status: 1,
          member_annual_income: 1,
          member_education_details: 1,
          member_collage_passout: 1,
          member_professional_status: 1,
          member_professional_details: 1,
          member_working_location: 1,
          member_father_name: 1,
          member_father_occupation: 1,
          member_father_occupation_details: 1,
          member_mother_name: 1,
          member_mother_occupation: 1,
          member_mother_occupation_details: 1,
          member_family_status: 1,
          member_family_income: 1,
          member_family_type: 1,
          member_family_values: 1,
          member_relatives_details: 1,
          member_gotra: 1,
          member_mama_gotra: 1,
          member_rashi: 1,
          member_tob: 1,
          member_place_of_birth: 1,
          member_manglik: 1,
          member_image: 1,
          member_horoscope_file: 1,
          member_city: 1,
          member_pincode: 1,
          member_address: 1,
          member_p_pincode: 1,
          member_p_address: 1,
          member_status: 1,
          member_district: 1,
          member_married_brothers: 1,
          member_unmarried_brothers: 1,
          member_married_sisters: 1,
          member_unmarried_sisters: 1,
          member_relative1_name: 1,
          member_relative1_number: 1,
          member_relative2_name: 1,
          member_relative2_number: 1,
          member_relative3_name: 1,
          member_relative3_number: 1
        }
      }
    ],
    callback
  );
};
module.exports.getMemInEventCount = (event, callback) => {
  // console.log(event);
  NewMember.countDocuments({ subscribed_events: { $in: event } }, callback);
};
module.exports.getUnapprovedMembers = callback => {
  NewMember.find({ member_is_approved: "N" }, callback);
};

module.exports.getMembersAddedBy = (addedBy, callback) => {
  NewMember.find({ member_added_by: addedBy }, callback);
};
module.exports.getMembersInAgeRange = (fromYear, toYear, callback) => {
  NewMember.aggregate(
    [
      {
        $match: {
          member_dob: { $gte: fromYear + "-00-00", $lte: toYear + "-00-00" }
        }
      },
      {
        $project: { member_dob: 1 }
      }
    ],

    callback
  );
};

module.exports.getAllMembersCount = callback => {
  NewMember.countDocuments(callback);
};

module.exports.getAllIds = callback => {
  NewMember.find({}, { _id: 1 }, callback);
};

module.exports.generateEmptyPasswords = (ids, pass, hash_pass, callback) => {
  NewMember.updateMany(
    {
      member_password: {
        $eq: ""
      },
      _id: {
        $in: ids
      }
    },
    {
      $set: {
        member_password: pass,
        member_hash_password: hash_pass
      }
    },
    callback
  );
};

module.exports.searchNewMember = (skip, keyword, callback) => {
  console.log(keyword);
  NewMember.aggregate(
    [
      {
        $match: {
          $or: [
            { member_id: { $all: keyword } },
            { member_profile_created_for: { $all: keyword } },
            { member_first_name: { $all: keyword } },
            { member_middle_name: { $all: keyword } },
            { member_last_name: { $all: keyword } },
            { member_name: { $all: keyword } },
            { member_mobile: { $all: keyword } }
          ]
        }
      }
    ],
    callback
  );
};

module.exports.searchNewMembers = (skip, keyword, callback) => {
  console.log(keyword);
  query = {
    $or: [
      { member_id: { $all: keyword } },
      { member_profile_created_for: { $all: keyword } },
      { member_name: { $all: keyword } },
      { member_mobile: { $all: keyword } },
      { member_email: { $all: keyword } }
    ]
  };
  NewMember.find(query, callback)
    .skip(skip)
    .limit(20);
};

module.exports.searchNewMembersCount = (keyword, callback) => {
  query = {
    $or: [
      { member_id: { $all: keyword } },
      { member_profile_created_for: { $all: keyword } },
      { member_name: { $all: keyword } },
      { member_mobile: { $all: keyword } },
      { member_email: { $all: keyword } }
    ]
  };
  NewMember.countDocuments(query, callback);
};

module.exports.searchNewMembersAllIds = (keyword, callback) => {
  query = {
    $or: [
      { member_id: { $all: keyword } },
      { member_profile_created_for: { $all: keyword } },
      { member_name: { $all: keyword } },
      { member_mobile: { $all: keyword } },
      { member_email: { $all: keyword } }
    ]
  };
  NewMember.find(query, { _id: 1 }, callback);
};

module.exports.getFilteredMembers = (
  fromYear,
  toYear,
  skip,
  sort,
  filter,
  callback
) => {
  query = {};
  if (filter.photoStatus[0] === "Without Photo") {
    query.$or = [
      { member_image: { $exists: false } },
      { member_image: { $eq: "" } }
    ];
  }
  if (filter.photoStatus[0] === "With Photo") {
    query.$and = [
      { member_image: { $exists: true } },
      { member_image: { $ne: "" } }
    ];
  }

  if (fromYear != "-1" && toYear != "-1") {
    if (fromYear.length && toYear.length) {
      query.member_dob = { $gte: fromYear + "-00-00", $lte: toYear + "-00-00" };
    }
  }

  // console.log(filter.member_professional_statuses);
  if (filter.member_professional_statuses) {
    filter.member_professional_statuses.length
      ? (query.member_professional_status = { $in: filter.member_professional_statuses })
      : false;
  }
  filter.genders.length
    ? (query.member_gender = { $in: filter.genders })
    : false;

  if (filter.religions && filter.religions.length && filter.religions[0]) {
    filter.religions.length
      ? (query.member_religion_name = { $in: filter.religions })
      : false;
  }
  filter.castes.length
    ? (query.member_caste_name = { $in: filter.castes })
    : false;
  filter.subcastes.length
    ? (query.$or = [
      { member_caste_name: { $in: filter.subcastes } },
      { member_sub_caste_name: { $in: filter.subcastes } }
    ])
    : false;
  // filter.subcastes.length
  //   ? (query.member_sub_caste_name = { $in: filter.subcastes })
  //   : false;
  filter.gotras.length ? (query.member_gotra = { $in: filter.gotras }) : false;
  filter.educations.length
    ? (query.member_education_details = { $in: filter.educations })
    : false;
  filter.motherTongues.length
    ? (query.member_mother_tongue = { $in: filter.motherTongues })
    : false;
  filter.familyIncomes.length
    ? (query.member_family_income = { $in: filter.familyIncomes })
    : false;
  filter.annualIncomes.length
    ? (query.member_annual_income = { $in: filter.annualIncomes })
    : false;
  filter.states.length
    ? (query.member_state_id = { $in: filter.states })
    : false;
  filter.cities.length
    ? (query.member_city_id = { $in: filter.cities })
    : false;
  filter.payStatus.length
    ? (query.member_is_paid = { $in: filter.payStatus })
    : false;
  filter.maritialStatus.length
    ? (query.member_meritial_status = { $in: filter.maritialStatus })
    : false;
  filter.investigated.length
    ? (query.member_is_investigated = { $in: filter.investigated })
    : false;
  filter.eatingHabit.length
    ? (query.member_eating_habits = { $in: filter.eatingHabit })
    : false;
  filter.visibility.length
    ? (query.member_is_visible = { $in: filter.visibility })
    : false;
  filter.physicallyChallanged.length
    ? (query.member_special_case = { $in: filter.physicallyChallanged })
    : false;
  filter.residentialStatus.length
    ? (query.member_residencial_status = { $in: filter.residentialStatus })
    : false;
  filter.events.length
    ? (query.subscribed_events = { $in: filter.events })
    : false;
  filter.member_details_verified_by_admin.length
    ? (query.member_details_verified_by_admin = {
      $in: filter.member_details_verified_by_admin
    })
    : false;
  filter.member_is_approved.length
    ? (query.member_is_approved = { $in: filter.member_is_approved })
    : false;
  filter.member_created_by.length
    ? (filter.member_created_by[0] == 'organic' ? (query.member_created_by = 'Self') : (query.member_created_by = { $ne: 'Self' }))
    : false;
  filter.bookPlans.length
    ? (query.subscribed_books = {
      $elemMatch: { _id: { $in: filter.bookPlans } }
    })
    : false;

  // console.log(query);
  NewMember.find(query, callback)
    .skip(skip)
    .limit(20)
    .sort(sort);
};

module.exports.getFilteredCounts = (fromYear, toYear, filter, callback) => {
  query = {};
  if (filter.photoStatus[0] === "Without Photo") {
    query.$or = [
      { member_image: { $exists: false } },
      { member_image: { $eq: "" } }
    ];
  }
  if (filter.photoStatus[0] === "With Photo") {
    query.$and = [
      { member_image: { $exists: true } },
      { member_image: { $ne: "" } }
    ];
  }

  if (fromYear != "-1" && toYear != "-1") {
    if (fromYear.length && toYear === null) {
      query.member_dob = { $gte: fromYear + "-00-00" };
    }
    if (fromYear === null && toYear.length) {
      query.member_dob = { $lte: toYear + "-00-00" };
    }
    if (fromYear.length && toYear.length) {
      query.member_dob = { $gte: fromYear + "-00-00", $lte: toYear + "-00-00" };
    }
  }
  filter.genders.length
    ? (query.member_gender = { $in: filter.genders })
    : false;
  // console.log(filter.member_professional_statuses);
  if (filter.member_professional_statuses) {
    filter.member_professional_statuses.length
      ? (query.member_professional_status = { $in: filter.member_professional_statuses })
      : false;
  }
  if (filter.religions && filter.religions.length && filter.religions[0]) {
    filter.religions.length
      ? (query.member_religion_name = { $in: filter.religions })
      : false;
  }
  filter.castes.length
    ? (query.member_caste_name = { $in: filter.castes })
    : false;
  filter.subcastes.length
    ? (query.$or = [
      { member_caste_name: { $in: filter.subcastes } },
      { member_sub_caste_name: { $in: filter.subcastes } }
    ])
    : false;
  // filter.subcastes.length
  //   ? (query.member_sub_caste_name = { $in: filter.subcastes })
  //   : false;
  filter.gotras.length ? (query.member_gotra = { $in: filter.gotras }) : false;
  filter.educations.length
    ? (query.member_education_details = { $in: filter.educations })
    : false;
  filter.motherTongues.length
    ? (query.member_mother_tongue = { $in: filter.motherTongues })
    : false;
  filter.familyIncomes.length
    ? (query.member_family_income = { $in: filter.familyIncomes })
    : false;
  filter.annualIncomes.length
    ? (query.member_annual_income = { $in: filter.annualIncomes })
    : false;
  filter.states.length
    ? (query.member_state_id = { $in: filter.states })
    : false;
  filter.cities.length
    ? (query.member_city_id = { $in: filter.cities })
    : false;

  filter.payStatus.length
    ? (query.member_is_paid = { $in: filter.payStatus })
    : false;
  filter.maritialStatus.length
    ? (query.member_meritial_status = { $in: filter.maritialStatus })
    : false;
  filter.investigated.length
    ? (query.member_is_investigated = { $in: filter.investigated })
    : false;
  filter.eatingHabit.length
    ? (query.member_eating_habits = { $in: filter.eatingHabit })
    : false;
  filter.visibility.length
    ? (query.member_is_visible = { $in: filter.visibility })
    : false;
  filter.physicallyChallanged.length
    ? (query.member_special_case = { $in: filter.physicallyChallanged })
    : false;
  filter.residentialStatus.length
    ? (query.member_residencial_status = { $in: filter.residentialStatus })
    : false;
  filter.events.length
    ? (query.subscribed_events = { $in: filter.events })
    : false;
  filter.member_details_verified_by_admin.length
    ? (query.member_details_verified_by_admin = {
      $in: filter.member_details_verified_by_admin
    })
    : false;
  filter.member_is_approved.length
    ? (query.member_is_approved = { $in: filter.member_is_approved })
    : false;
  filter.member_created_by.length
    ? (filter.member_created_by[0] == 'organic' ? (query.member_created_by = 'Self') : (query.member_created_by = { $ne: 'Self' }))
    : false;
  filter.bookPlans.length
    ? (query.subscribed_books = {
      $elemMatch: { _id: { $in: filter.bookPlans } }
    })
    : false;
    console.log(query);

  NewMember.find(query, { _id: 1 }, callback);
};
//Get members with plan less than

module.exports.getLessPlanMembers = callback => {
  NewMember.find(
    {
      $or: [
        { member_plan_id: "1499" },
        { member_plan_id: "999" },
        { member_plan_id: "5999" },
        { member_plan_id: { $exists: false } }
      ]
    },
    callback
  );
};
module.exports.getLessPlanMemberIds = callback => {
  NewMember.find(
    null,
    { member_id: true },
    {
      $or: [
        { member_plan_id: "1499" },
        { member_plan_id: "999" },
        { member_plan_id: "5999" },
        { member_plan_id: { $exists: false } }
      ]
    },
    callback
  );
};
module.exports.getLessPlanMemberIdsCount = callback => {
  NewMember.countDocuments(
    {
      $or: [
        { member_plan_id: "1499" },
        { member_plan_id: "999" },
        { member_plan_id: "5999" },
        { member_plan_id: { $exists: false } }
      ]
    },
    callback
  );
};

module.exports.searchByMemberId = (id, callback) => {
  NewMember.findOne({ member_id: id }, callback);
};
module.exports.deleteMember = (id, callback) => {
  NewMember.findByIdAndDelete(id, callback);
};

//Validate mobile
module.exports.validateMobile = (mobile, callback) => {
  NewMember.findOne({ member_mobile: mobile }, callback);
};
module.exports.validateEmail = (email, callback) => {
  NewMember.findOne({ member_email: email }, callback);
};
module.exports.validateMemberId = (memid, callback) => {
  NewMember.findOne({ member_id: memid }, callback);
};

module.exports.comparePassword = (candidatePassword, hash, callback) => {
  bcrypt.compare(candidatePassword, hash, (err, isMatch) => {
    if (err) throw err;
    callback(null, isMatch);
  });
};

module.exports.getDuplicateMembersByMobile = callback => {
  NewMember.aggregate(
    [
      {
        $group: {
          _id: { member_mobile: "$member_mobile" },
          count: { $sum: 1 }
        }
      },
      { $match: { count: { $gt: 1 } } }
    ],
    callback
  );
};
module.exports.getDuplicateMembersByEmail = callback => {
  NewMember.aggregate(
    [
      {
        $group: {
          _id: { member_email: "$member_email" },
          count: { $sum: 1 }
        }
      },
      { $match: { count: { $gt: 1 } } }
    ],
    callback
  );
};
module.exports.getDuplicateMembersByName = callback => {
  NewMember.aggregate(
    [
      {
        $group: {
          _id: { member_name: "$member_name" },
          count: { $sum: 1 }
        }
      },
      { $match: { count: { $gt: 1 } } }
    ],
    callback
  );
};

module.exports.findByIds = (ids, callback) => {
  NewMember.find({ member_mobile: { $in: ids } }, callback);
};

module.exports.findByIdsEmail = (ids, callback) => {
  NewMember.find({ member_email: { $in: ids } }, callback);
};

module.exports.findByIdsName = (ids, callback) => {
  NewMember.find({ member_name: { $in: ids } }, callback);
};

module.exports.getMembersByMobile = (mobile, callback) => {
  NewMember.find({ member_mobile: mobile }, callback);
};

module.exports.getAllMembersByIds = (ids, callback) => {
  NewMember.find({ _id: { $in: ids } }, callback);
};

module.exports.getSuggestedProfileForDoc = (doc, evIds, callback) => {
  if (doc.member_gender === "Male") {
    NewMember.find(
      {
        member_gender: "Female",
        subscribed_events: { $in: evIds }
      },
      callback
    ).limit(50);
  } else {
    NewMember.find(
      {
        member_gender: "Male",
        subscribed_events: { $in: evIds }
      },
      callback
    ).limit(50);
  }
};

module.exports.getMatchesByPartnerPrefrence = (m_pp, callback) => {
  let desiredKeys = [];
  // console.log(m_pp);
  for (const k of Object.keys(m_pp)) {
    if (typeof m_pp[k] === "object") {
      if (m_pp[k].length) {
        desiredKeys.push(k);
      } else {
        delete m_pp[k];
      }
    } else {
      if (m_pp[k]) {
        desiredKeys.push(k);
      } else {
        delete m_pp[k];
      }
    }
  }
  let queries = [];
  if (m_pp.desired_body_type) {
    queries.push({ member_body_type: { $in: m_pp.desired_body_type } });
  }
  if (m_pp.desired_height_from && m_pp.desired_height_to) {
    queries.push({
      $and: [
        {
          member_height: {
            $gte: m_pp.desired_height_from
          }
        },
        {
          member_height: {
            $lte: m_pp.desired_height_to
          }
        }
      ]
    });
  }
  if (m_pp.desired_weight_from && m_pp.desired_weight_to) {
    queries.push({
      $and: [
        {
          member_weight: {
            $gte: m_pp.desired_weight_from
          }
        },
        {
          member_weight: {
            $lte: m_pp.desired_weight_to
          }
        }
      ]
    });
  }
  if (m_pp.desired_maritial_status) {
    queries.push({ member_meritial_status: m_pp.desired_maritial_status });
  }
  if (m_pp.desired_maritial_status) {
    queries.push({ member_meritial_status: m_pp.desired_maritial_status });
  }
  if (m_pp.desired_religion) {
    queries.push({ member_religion_name: { $in: m_pp.desired_religion } });
  }
  if (m_pp.desired_caste) {
    queries.push({ member_caste_name: { $in: m_pp.desired_caste } });
  }
  if (m_pp.desired_mother_tongue) {
    queries.push({ member_mother_tongue: { $in: m_pp.desired_mother_tongue } });
  }
  if (m_pp.desired_manglik) {
    queries.push({ member_manglik: { $in: m_pp.desired_manglik } });
  }
  if (m_pp.desired_education) {
    queries.push({ member_education_details: { $in: m_pp.desired_education } });
  }
  if (m_pp.desired_occupation) {
    queries.push({ member_occupationdummy: { $in: m_pp.desired_occupation } });
  }
  if (m_pp.desired_income) {
    queries.push({ member_annual_income: { $in: m_pp.desired_income } });
  }
  if (m_pp.desired_own_house) {
    queries.push({ member_own_house_status: m_pp.desired_own_house });
  }
  if (m_pp.desired_family_status) {
    queries.push({ member_family_status: { $in: m_pp.desired_family_status } });
  }
  if (m_pp.desired_family_income) {
    queries.push({ member_family_income: { $in: m_pp.desired_family_income } });
  }
  if (m_pp.desired_family_type) {
    queries.push({ member_family_type: m_pp.desired_family_type });
  }
  if (m_pp.desired_family_value) {
    queries.push({ member_family_values: { $in: m_pp.desired_family_value } });
  }
  if (m_pp.desired_family_residential_status) {
    queries.push({
      member_residencial_status: { $in: m_pp.desired_family_residential_status }
    });
  }
  if (m_pp.desired_eating_habit) {
    queries.push({ member_eating_habits: m_pp.desired_eating_habit });
  }
  if (m_pp.desired_drinking_habit) {
    queries.push({ member_drinking_habits: m_pp.desired_drinking_habit });
  }
  if (m_pp.desired_smoking_habit) {
    queries.push({ member_smoking_habits: m_pp.desired_smoking_habit });
  }
  if (m_pp.desired_complexion) {
    queries.push({ member_complextion: m_pp.desired_complexion });
  }
  if (m_pp.desired_abled) {
    queries.push({ member_special_case: m_pp.desired_abled });
  }
  console.log(queries);

  // console.log(Object.keys(m_pp._doc));
  NewMember.find(
    {
      $and: queries
    },
    { _id: 1 },
    callback
  );
};
