const mongoose = require('mongoose');
const config = require('../config/database');

const occupationSchema = mongoose.Schema({
    occupation_id: { type: String, required: true },
    occupation_title: { type: String, required: true },
    occupation_slug: { type: String,  },
    occupation_for: { type: Boolean, },
    occupation_is_deleted: { type: Boolean,  },
    occupation_added_by: { type: String },
    occupation_order: { type: String },
    occupation_status: { type: String },
    occupation_created_on: { type: Date, default: Date.now() },

},{collection: 'sbw_occupations'});

const Occupation = (module.exports = mongoose.model('sbw_occupations', occupationSchema));

// Add occupation
module.exports.addOccupation = (occupation, callback) => {
	Occupation.create(occupation, callback);
}

// read occupation
module.exports.getOccupation = (callback, limit) => {
	Occupation.find(callback).limit(limit);
}
module.exports.getDesiredOccupation = (id,callback) => {
	Occupation.find({occupation_id: {$in: id}},callback);
}

//find a occupation by id
module.exports.getOccupationById=(Id,callback)=>{
  Occupation.findOne({"occupation_id":Id},callback);
}

//find a occupation by title
module.exports.getOccupationByTitle=(title,callback)=>{
  Occupation.findOne({"occupation_title":title},callback);
}


// Update occupation
module.exports.updateOccupation = (id, occupation, options, callback) => {
	var query = {occupation_id: id};
  var update = {};
  if(occupation.occupation_title){
    update.occupation_title= occupation.occupation_title
  }
  if(occupation.occupation_slug){
    update.occupation_slug= occupation.occupation_slug
  }
  if(occupation.occupation_for){
    update.occupation_for= occupation.occupation_for
  }
  if(occupation.occupation_is_deleted){
    update.occupation_is_deleted= occupation.occupation_is_deleted
  }
  if(occupation.occupation_added_by){
    update.occupation_added_by= occupation.occupation_added_by
  }
  if(occupation.occupation_order){
    update.occupation_order= occupation.occupation_order
  }
  if(occupation.occupation_status){
    update.occupation_status= occupation.occupation_status
  }
  if(occupation.occupation_created_on){
    update.occupation_created_on= occupation.occupation_created_on
  }
        
	Occupation.findOneAndUpdate(query, update, options, callback);
}


// Delete Occupation
module.exports.removeOccupation = (id, callback) => {
	var query = {occupation_id: id};
	Occupation.remove(query, callback);
}


