const mongoose = require('mongoose');
const config = require('../config/database');

const officePackSchema = mongoose.Schema({
  name: { type: String },
  amount: { type: Number },
  remark: { type: String },
  distributionCount: { type: String },
  topOfficePack: { type: String, default: 'main' },
  commission: { type: Number, default: 100 },
  createdBy: { type: String },
  updatedBy: { type: String },
  createdAt: { type: Date, default: Date.now() },
  updatedAt: { type: Date }
});

const OfficePack = (module.exports = mongoose.model('officePack', officePackSchema));

module.exports.addOfficePack = (newOfficePack, callback) => {
  newOfficePack.save(callback);
};

module.exports.getOfficePackByTopOfficePack = (topOfficePack, callback) => {
  OfficePack.findOne({ topOfficePack: topOfficePack }, callback);
};

module.exports.getOfficePackbyName = (officePack, callback) => {
  OfficePack.findOne({ name: officePack }, callback);
};

module.exports.getOfficePackDistributionCount = (officePack, callback) => {
  OfficePack.findOne({ name: officePack }, { distributionCount: 1 }, callback);
};

module.exports.getOfficePackById = (id, callback) => {
  OfficePack.findOne({ _id: id }, callback);
};

module.exports.getAllOfficePacks = callback => {
  OfficePack.find(callback);
};

module.exports.deleteOfficePack = (id, callback) => {
  OfficePack.findByIdAndDelete(id, callback);
};
