const mongoose = require("mongoose");
const config = require("./../config/database");

const otpSchema = mongoose.Schema(
  {
    reference: {
        type: String
    },
    referenceType: {
        type: String
    },
    otp: {
        type: String
    },
    createdAt: {
        type: String
    }
  },
  { collection: "otps" }
);

const Otp = (module.exports=mongoose.model('otps', otpSchema));

// Create and update
module.exports.addOtp = (newOtp, callback) => {
  newOtp.save(callback);
};
// Get by id
module.exports.getOtp = (id, callback) => {
    Otp.findById(id, callback);
};
//Get all otps
module.exports.getAllOtp = callback => {
    Otp.find(callback);
};

//Get otp by otp name
module.exports.getOtpByName = (otpName, callback)=>{
    Otp.find({otp: otpName}, callback);
}

//Get reference
module.exports.getOtpReference = (reference, callback)=>{
    Otp.findOne({reference: reference}, callback);
}

//Delete by id
module.exports.deleteOtp = (id, callback) => {
    Otp.findByIdAndDelete(id, callback);
};

