const mongoose = require('mongoose');
const config = require('../config/database');

const PrivilageCoupenSchema = mongoose.Schema({
    name: { type: String, },
    shortName: { type: String },
    description: { type: String },
    discount: { type: Number },
    low: { type: Number },
    high: { type: Number },
});

const PrivilageCoupen = (module.exports = mongoose.model('privilageCoupen', PrivilageCoupenSchema));

module.exports.addPrivilageCoupen = (newRange, callback) => {
    newRange.save(callback);
};

module.exports.getPrivilageCoupenByName = (name, callback) => {
    PrivilageCoupen.findOne({ name: name }, callback);
};

module.exports.getPrivilageCoupenByShortName = (SN, callback) => {
    PrivilageCoupen.findOne({ shortName: SN }, callback);
};

module.exports.getAllPrivilageCoupen = callback => {
    PrivilageCoupen.find(callback);
};

module.exports.getPrivilageCoupenById = (id, callback) => {
    PrivilageCoupen.findOne({ _id: id }, callback);
};

module.exports.getPrivilageCoupenByLowValue = (low, callback) => {
    PrivilageCoupen.findOne({ low: low }, callback);
};

module.exports.getPrivilageCoupenByHighValue = (high, callback) => {
    PrivilageCoupen.findOne({ high: high }, callback);
};

module.exports.getPrivilageCoupenByLowHigh = (low, high, callback) => {
    PrivilageCoupen.findOne({ $and: [{ low: low }, { high: high }] }, callback);
};

module.exports.getInRange = (low, high, callback) => {
    PrivilageCoupen.find({ $and: [{ low: { $gt: low } }, { high: { $lt: high } }] }, callback);
};
