const mongoose = require('mongoose');
const config = require('../config/database');

const rashiSchema = mongoose.Schema({
    rashi_id: { type: String, required: true },
    rashi_name: { type: String, required: true },
    rashi_slug: { type: String },
    rashi_is_deleted: { type: String  },
    rashi_added_by: { type: String },
    rashi_order: { type: String },
    rashi_status: { type: String },
    rashi_created_on: { type: Date, default: Date.now() },
}, { collection: 'sbw_rashi'});

const Rashi = (module.exports = mongoose.model('sbw_rashi', rashiSchema));

// Add rashi
module.exports.addRashi = (rashi, callback) => {
	Rashi.create(rashi, callback);
}

// read rashi
module.exports.getRashi = (callback) => {
	Rashi.find(callback);
}

//find a rashi by id
module.exports.getRashiById=(Id,callback)=>{
  Rashi.findOne({"rashi_id":Id},callback);
}

//find a rashi by title
module.exports.getRashiByName=(name,callback)=>{
  Rashi.findOne({"rashi_name":name},callback);
}


// Update rashi
module.exports.updateRashi = (id, rashi, options, callback) => {
    var query = {rashi_id: id};
    var update = {};
    
    
    if(rashi.rashi_name){
        update.rashi_name = rashi.rashi_name;
    }
    if(rashi.rashi_slug){
        update.rashi_slug = rashi.rashi_slug;
    }
    if(rashi.rashi_is_deleted){
        update.rashi_is_deleted = rashi.rashi_is_deleted;
    }
    if(rashi.rashi_added_by){
        update.rashi_added_by = rashi.rashi_added_by;
    }
    if(rashi.rashi_order){
        update.rashi_order = rashi.rashi_order;
    }
    if(rashi.rashi_status){
        update.rashi_status = rashi.rashi_status;
    }
    Rashi.findOneAndUpdate(query, update, options, callback);
}


// Delete Rashi
module.exports.removeRashi = (id, callback) => {
	var query = {rashi_id: id};
	Rashi.remove(query, callback);
}


