const mongoose = require('mongoose');
const config = require('../config/database');

const RemainderSchema = mongoose.Schema({
  alarmDate: { type: Date },
  alarmForLead: { type: JSON },
  alarmSetBy: { type: String },
  createdAt: { type: Date, default: Date.now(), },
  read: { type: Boolean, default: false }
});

const Remainder = (module.exports = mongoose.model(
  'remainder',
  RemainderSchema
));

module.exports.addRemainder = (newRemainder, callback) => {
  newRemainder.save(callback);
};

module.exports.getRemainderById = (id, callback) => {
  Remainder.findById(id, callback);
};

module.exports.getRemainderByUsername = (username, callback) => {
  const date = new Date();
  Remainder.find(
    {
      $and: [{ alarmSetBy: username }, { alarmDate: { $gte: date } }]
    },
    callback
  ).sort("alarmDate");
};

module.exports.getRemainderByUsernames = (username, callback) => {
  const date = new Date();
  Remainder.find(
    {
      $and: [{ alarmSetBy: { $in: usernames } }, { alarmDate: { $gte: date } }]
    },
    callback
  ).sort("alarmDate");
};

module.exports.getRemaindersByDate = (date, callback) => {
  Remainder.find({ alarmDate: { $lte: date } }, callback).sort("alarmDate");
};

module.exports.getRemaindersByUsernamesCount = (usernames, callback) => {
  let date = new Date();
  Remainder.countDocuments({ alarmSetBy: { $in: usernames }, alarmDate: { $gte: date }, read: false }, callback);
};

module.exports.getRemaindersByUsernamesLimited = (usernames, limit, skip, callback) => {
  let date = new Date();
  Remainder.find({ alarmSetBy: { $in: usernames }, alarmDate: { $gte: date }, read: false }, callback).sort("alarmDate").limit(limit).skip(skip);
};

module.exports.getRemaindersByUsernames = (usernames, callback) => {
  let date = new Date();
  Remainder.find({ alarmSetBy: { $in: usernames }, alarmDate: { $gte: date }, read: false }, callback).sort("alarmDate");
};

module.exports.getRemaindersByUsernameByDateUnread = (username, date, callback) => {
  Remainder.find({ alarmSetBy: username, alarmDate: { $lte: date }, read: false }, callback).sort("alarmDate");
};

module.exports.getRemaindersByUsernamesByDateUnread = (usernames, date, callback) => {
  Remainder.find({ alarmSetBy: { $in: usernames }, alarmDate: { $lte: date }, read: false }, callback).sort("alarmDate");
};

module.exports.getRemaindersByUsernamesByDateRead = (usernames, date, callback) => {
  Remainder.find({ alarmSetBy: { $in: usernames }, alarmDate: { $lte: date }, read: true }, callback).sort("alarmDate");
};

module.exports.getRemaindersByUsernameByDateRead = (username, date, callback) => {
  Remainder.find({ alarmSetBy: username, alarmDate: { $lte: date }, read: true }, callback).sort("alarmDate");
};

module.exports.getAllRemainder = callback => {
  Remainder.find(callback).sort("alarmDate");
};
