const mongoose = require('mongoose');
const config = require('../config/database');

const sourceSchema = mongoose.Schema({
  sourceName: { type: String, unique: true, dropDups: true },
  shortName: { type: String, unique: true, dropDups: true },
  show: { type: String, default: 'Y' },
  sourceCode: { type: String },
  sourceId: { type: String },
  allotedBy: { type: String },
  createdAt: { type: Date, default: Date.now() }
});

sourceSchema.path('shortName').index({ unique: true });

const Source = (module.exports = mongoose.model('source', sourceSchema));

module.exports.addSource = (newSource, callback) => {
  newSource.save(callback);
};

module.exports.getSourceBySourcecode = (sourcecode, callback) => {
  Source.findOne({ sourceCode: sourcecode }, callback);
};

module.exports.getSourcebyName = (source, callback) => {
  Source.findOne({ sourceName: source }, callback);
};

module.exports.getSourcebyShortname = (source, callback) => {
  Source.findOne({ shortName: source }, callback);
};

module.exports.getSourceById = (id, callback) => {
  Source.findOne({ _id: id }, callback);
};

module.exports.getAllSources = callback => {
  Source.find(callback);
};

module.exports.deleteSource = (sName, callback) => {
  Source.findOneAndDelete({ sourceName: sName }, callback);
};
