const mongoose = require("mongoose");
const config = require("../config/database");

const DesiredSchema = mongoose.Schema(
    {
        desired_id: {
            type: String
        },
        desired_member_slug: {
            type: String
        },
        desired_age_from: {
            type: String
        },
        desired_age_to: {
            type: String
        },
        desired_gender: {
            type: String
        },
        desired_body_type: {
            type: String
        },
        desired_height_from: {
            type: String
        },
        desired_height_to: {
            type: String
        },
        desired_weight_from: {
            type: String
        },
        desired_weight_to: {
            type: String
        },
        desired_maritial_status: {
            type: String
        },
        desired_country: {
            type: String
        },
        desired_religion_all: {
            type: String,
            default: 'N'
        },
        desired_religion: {
            type: String
        },
        desired_caste: {
            type: String
        },
        desired_sub_caste: {
            type: String
        },
        desired_mother_tongue: {
            type: String
        },
        desired_manglik: {
            type: String
        },
        desired_gotra: {
            type: String
        },
        desired_mama_gotra: {
            type: String
        },
        desired_education: {
            type: String
        },
        desired_occupation: {
            type: String
        },
        desired_income: {
            type: String
        },
        desired_own_house: {
            type: String
        },
        desired_family_status: {
            type: String
        },
        desired_family_income: {
            type: String
        },
        desired_family_type: {
            type: String
        },
        desired_family_value: {
            type: String
        },
        desired_family_residential_status: {
            type: String
        },
        desired_eating_habit: {
            type: String
        },
        desired_drinking_habit: {
            type: String
        },
        desired_smoking_habit: {
            type: String
        },
        desired_complexion: {
            type: String
        },
        desired_abled: {
            type: String
        },
        desired_abled_details: {
            type: String
        },
        desired_about_partner: {
            type: String
        },
        desired_is_deleted: {
            type: String
        },
        desired_created_on: {
            type: Date
        },
        desired_member_id: {
            type: String
        },
        desired_user_id: {
            type: String
        },
        desired_status: {
            type: String
        },
    },
    { collection: "ss_desired" }
);

const Desired = (module.exports = mongoose.model("ss_desired", DesiredSchema));

// Create and update
module.exports.addDesired = (newDesired, callback) => {
    newDesired.save(callback);
};
// Get by id
module.exports.getDesired = (id, callback) => {
    Desired.findById(id, callback);
};
// Get by member id
module.exports.getDesiredByMember = (id, callback) => {
    Desired.find({ desired_member_id: id }, callback);
};
//Get all desireds
module.exports.getAllDesired = callback => {
    Desired.find(callback);
};


//Delete by id
module.exports.deleteDesired = (id, callback) => {
    Desired.findByIdAndDelete(id, callback);
};
