const _ = require('lodash');
const express = require('express');
const router = express.Router();
const passport = require('passport');
const Area = require('../models/area');
const Helpers = require('../Helpers/Helpers');

router.post('/check-duplicate', passport.authenticate('jwt', { session: false }), (req, res) => {
    let ar = req.body.area;
    let c = ar.city;
    let d = ar.district;
    let s = ar.state;
    console.log(Helpers.firstUpper(ar.city));
    Area.duplicateCheck(c, d, s, (err, area) => {
        if (err) {
            res.json({ success: false, msg: 'Error occured', err: JSON.stringify(err) });
        } else {
            // console.log(area);
            if (area) {
                // console.log('Area found')
                if ((area.city == ar.city) && (area.state == ar.state) && (area.country == ar.country) && (area.district == ar.district)) {
                    console.log("Duplicate data");
                    console.log(area);
                    res.json({ success: false, msg: 'Duplicate data', area: area });
                } else {
                    if ((area.city != ar.city) || (area.state == ar.state) || (area.country == ar.country) || (area.district == ar.district)) {
                        console.log("No duplicate data");
                        res.json({ success: true, msg: 'No duplicate data found', area: ar });
                    }
                }
            } else {
                // console.log("Else")
                res.json({ success: true, msg: 'No duplicate data found', area: ar });
            }
        }
    });
});

router.post(
    '/upload-bulk-areas',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        let error = false;
        // let newAreas = req.body.newAreas;
        Area.insertArrayofAreas(req.body.newAreas, (err, areas) => {
            if (err) {
                res
                    .status(200)
                    .json({ success: false, msg: 'Error occured', err: err });
            } else {
                res
                    .status(200)
                    .json({ success: true, msg: 'upload successful', areas: areas });
            }
        });
    });

router.post('/create-area', passport.authenticate('jwt', { session: false }), (req, res) => {
    let type = req.body.type;
    if (type == 'country') {
        Area.getCountryByName(req.body.countryName, (err, country) => {
            if (err) {
                res.json({ success: false, msg: 'Area not created...', err: err });
            } else {
                if (country) {
                    res.json({ success: false, msg: 'Country is already exist' });
                } else {
                    let newArea = new Area({
                        country: req.body.countryName,
                        type: 'country'
                    });
                    Area.addArea(newArea, (err, area) => {
                        if (err) {
                            res.json({ success: false, msg: 'Area not created...', err: err });
                        } else {
                            if (area) {
                                res.json({ success: true, msg: 'Area is created successfully', area: area });
                            } else {
                                res.json({ success: false, msg: 'Area is not created successfully ' });
                            }
                        }
                    });
                }
            }
        });

    } else if (type == 'state') {
        Area.getStateByName(req.body.stateName, (err, area) => {
            if (err) {
                res.json({ success: false, msg: 'Area is not created successfully', err: err });
            } else {
                if (area && ((area.country == req.body.countryName))) {
                    res.json({ success: false, msg: 'State already exist' });
                } else {
                    let newArea = new Area({
                        country: req.body.countryName,
                        state: req.body.stateName,
                        type: 'state'
                    });
                    Area.addArea(newArea, (err, area) => {
                        if (err) {
                            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
                        } else {
                            if (area) {
                                res.json({ success: true, msg: 'Area is created successfully', area: area });
                            } else {
                                res.json({ success: false, msg: 'Area is not created successfully ' });
                            }
                        }
                    });
                }
            }
        });

    } else if (type == 'district') {
        Area.getDistrictByName(req.body.districtName, (err, area) => {
            if (err) {
                res.json({ success: false, msg: 'Error in creating district', err: err });
            } else {
                if (area && ((area.state == req.body.stateName) && (area.country == req.body.countryName))) {
                    res.json({ success: false, msg: 'District is already exit' });
                } else {
                    let newArea = new Area({
                        country: req.body.countryName,
                        state: req.body.stateName,
                        district: req.body.districtName,
                        type: 'district'
                    });
                    Area.addArea(newArea, (err, area) => {
                        if (err) {
                            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
                        } else {
                            if (area) {
                                res.json({ success: true, msg: 'Area is created successfully', area: area });
                            } else {
                                res.json({ success: false, msg: 'Area is not created successfully ' });
                            }
                        }
                    });
                }
            }
        });

    } else if (type == 'city') {
        Area.getCityByName(req.body.cityName, (err, area) => {
            if (err) {
                res.json({ success: false, msg: 'Error in creating city', err: err });
            } else {
                if (area && ((area.state == req.body.stateName) && (area.country == req.body.countryName) && (area.district == req.body.districtName))) {
                    res.json({ success: false, msg: 'City already exist' });
                } else {
                    let area = new Area({
                        country: req.body.countryName,
                        state: req.body.stateName,
                        district: req.body.districtName,
                        city: req.body.cityName,
                        type: 'city'
                    });
                    Area.addArea(area, (err, area) => {
                        if (err) {
                            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
                        } else {
                            if (area) {
                                res.json({ success: true, msg: 'Area is created successfully', area: area });
                            } else {
                                res.json({ success: false, msg: 'Area is not created successfully ' });
                            }
                        }
                    });
                }
            }
        });
    }
});

// ************* Cities *************
router.get('/get-all-cities', passport.authenticate('jwt', { session: false }), (req, res) => {
    Area.getCities((err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching cities' });
        } else {
            res.json({ success: true, msg: 'Cities are found', cities: cities });
        }
    });
});

// cities by keyword
router.post('/getCountriesByName', passport.authenticate('jwt', { session: false }), (req, res) => {
    let query = req.body.query;
    // console.log(country);
    Area.getCountriesByName(query, (err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
        } else {
            let uniqCities = _.uniqBy(cities, (e) => e.country);
            // console.log(uniqCities);
            res.json({ success: true, msg: 'Cities are found', cities: uniqCities });
        }
    });
});
router.post('/getDistrictsByName', passport.authenticate('jwt', { session: false }), (req, res) => {
    let query = req.body.query;
    // console.log(country);
    Area.getDistrictsByName(query, (err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
        } else {
            let uniqCities = _.uniqBy(cities, (e) => e.district);
            // console.log(uniqCities);
            res.json({ success: true, msg: 'Cities are found', cities: uniqCities });
        }
    });
});
router.post('/getStatesByName', passport.authenticate('jwt', { session: false }), (req, res) => {
    let query = req.body.query;
    // console.log(country);
    Area.getStatesByName(query, (err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
        } else {
            let uniqCities = _.uniqBy(cities, (e) => e.state);
            // console.log(uniqCities);
            res.json({ success: true, msg: 'Cities are found', cities: uniqCities });
        }
    });
});
router.post('/getCitiesByName',
    (req, res) => {
        let query = req.body.query;
        // console.log(country);
        Area.getCitiesByName(query, (err, cities) => {
            if (err) {
                res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
            } else {
                let uniqCities = _.uniqBy(cities, (e) => e.city);
                // console.log(uniqCities);
                res.json({ success: true, msg: 'Cities are found', cities: uniqCities });
            }
        });
    });




// cities by district
router.post('/getCitiesByCountry', passport.authenticate('jwt', { session: false }), (req, res) => {
    let country = req.body.country;
    // console.log(country);
    Area.getCitiesByCountry(country, (err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching cities of country ', err: JSON.stringify(err) });
        } else {
            let uniqCities = _.uniqBy(cities, (e) => e.city);
            // console.log(uniqCities);
            res.json({ success: true, msg: 'Cities are found', cities: uniqCities });
        }
    });
});

router.post('/get-cities-by-district', (req, res) => {
    let district = req.body.districtName;
    Area.getCitiesByDistrict(district, (err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'cities not fetched successfully ', err: err });
        } else {
            let uniqCities = [];
            for (let i = 0; i < cities.length; i++) {
                uniqCities.push({
                    city: cities[i]._id,
                    district: cities[i].district[0],
                    state: cities[i].state[0],
                    country: cities[i].country[0]
                });
            }
            res.json({ success: true, msg: 'Cities Fetched', cities: uniqCities });
        }
    });
});

// cities by state
router.post('/get-cities-by-state', passport.authenticate('jwt', { session: false }), (req, res) => {
    let state = req.body.stateName;
    Area.getDataByState(state, (err, states) => {
        if (err) {
            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
        } else {
            let uniqCities = _.uniqBy(states, (e) => e.city);
            res.json({ success: true, msg: 'States may contain cities', states: uniqCities });
        }
    });
});

// get city by id
router.post('/get-city-by-id', passport.authenticate('jwt', { session: false }), (req, res) => {
    let id = req.body.cityId;
    Area.getDataByState(id, (err, city) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching city ', err: err });
        } else {
            if (city) {
                res.json({ success: true, msg: 'city found', states: states });
            } else {
                res.json({ success: false, msg: 'city not found' });
            }
        }
    });
});

// get city by name
router.post('/get-cities', passport.authenticate('jwt', { session: false }), (req, res) => {
    let city = req.body.city;
    Area.getStates(city, (err, cities) => {
        if (err) {
            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
        } else {
            res.json({ success: true, msg: 'cities', cities: cities });
        }
    });
});

// **************** States *******************
// states by country
router.post('/get-states-by-country', passport.authenticate('jwt', { session: false }), (req, res) => {
    let country = req.body.countryName;
    Area.getStatesByCountry(country, (err, states) => {
        if (err) {
            res.json({ success: false, msg: `Failed to fetch state by country : ${req.body.countryName}`, err: err });
        } else {
            let uniqStates = [];
            for (let i = 0; i < states.length; i++) {
                uniqStates.push({
                    state: states[i]._id
                });
            }
            res.json({ success: true, msg: 'Countries may contain cities', states: uniqStates });
        }
    });
});

// get States by name
router.post('/get-states', passport.authenticate('jwt', { session: false }), (req, res) => {
    let state = (req.body.stateName);
    Area.getStates(state, (err, states) => {
        if (err) {
            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
        } else {
            res.json({ success: true, msg: 'Districts', states: states });
        }
    });
});

// get all states
router.get('/getAllStates', (req, res) => {
    Area.getAllStates((err, states) => {
        if (err) {
            res.json({ success: false, msg: 'Error in fetching all states', err: JSON.stringify(err) });
        } else {
            let uniqStates = [];
            for (let i = 0; i < states.length; i++) {
                uniqStates.push({ state: states[i]._id });
            }
            res.json({ success: true, msg: 'States are found', states: uniqStates });
        }
    });
});



// **************** Districts *****************
// Districts by State
router.post('/get-districts-by-state', (req, res) => {
    let state = (req.body.stateName);
    Area.getDistrictByState(state, (err, districts) => {
        if (err) {
            res.json({ success: false, msg: `Failed to fetch districts by state : ${req.body.stateName}`, err: err });
        } else {
            let uniqdistricts = [];
            for (let i = 0; i < districts.length; i++) {
                uniqdistricts.push({
                    district: districts[i]._id
                });
            }
            res.json({ success: true, msg: 'Districts may contain cities', districts: uniqdistricts });
        }
    });
});

// get districs by Name
router.get('/get-districts', passport.authenticate('jwt', { session: false }), (req, res) => {
    let dist = (req.body.districtName);
    Area.getDistricts(dist, (err, districts) => {
        if (err) {
            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
        } else {
            res.json({ success: true, msg: 'Districts', districts: districts });
        }
    });
});

router.get('/get-all-districts', passport.authenticate('jwt', { session: false }), (req, res) => {
    Area.getAllDistricts((err, districts) => {
        // if (err) {
        //     res.json({ success: false, msg: 'Error occured successfully ', err: err });
        // } else {
        //     let uniqDists = _.uniqBy(districts, (e) => e.district);
        //     res.json({ success: true, msg: 'Districts', districts: uniqDists });
        // }
        if (err) {
            res.json({ success: false, msg: 'Error occured successfully ', err: err });
        } else {
            let uniqDists = [];
            for (let i = 0; i < districts.length; i++) {
                uniqDists.push({ district: districts[i]._id });
            }
            res.json({ success: true, msg: 'Districts', districts: uniqDists });
        }
    });
});


// **************** Countries *****************
// All Countries
router.get('/get-countries', passport.authenticate('jwt', { session: false }), (req, res) => {
    // console.log("Called");
    Area.getCountries((err, countries) => {
        if (err) {
            res.json({ success: false, msg: 'Area is not created successfully ', err: err });
        } else {
            // console.log(countries);
            let uniqCountries = [];
            for (let i = 0; i < countries.length; i++) {
                uniqCountries.push({
                    country: countries[i]._id
                });
            }
            res.json({ success: true, msg: 'Countries', countries: uniqCountries });

        }
    });
});




// Edit
router.post('/edit-country', passport.authenticate('jwt', { session: false }), (req, res) => {
    let updatedData = [];
    // console.log(req.body.country);
    // console.log(req.body.newCountry);

    if (req.body.country && req.body.newCountry) {

        // Area.getCountriesByName(req.body.country, (err, data) => {
        //     for (let i = 0; i < data.length; i++) {
        //         data[i].country = (req.body.newCountry);
        //         Area.addArea(data[i], (err, updated) => {
        //             if (err) {
        //                 res.json({ success: false, msg: 'error', err: JSON.stringify(err) });
        //             } else {
        //                 // console.log(updated)
        //                 updatedData.push(updated);
        //             }
        //         });
        //     }
        //     res.json({ success: true, msg: 'Country updated successfully', updated: updatedData })
        // });
        Area.updateCountry(req.body.country, req.body.newCountry, (err, data) => {
            if (err) {
                res.json({ success: false, msg: 'error', err: JSON.stringify(err) });
            } else {
                // console.log(updated)
                updatedData.push(data);
                res.json({ success: true, msg: 'Country updated successfully', updated: data })
            }
        });
    } else {
        res.json({ success: false, msg: 'Data is not sufficient' })
    }
});

router.post('/edit-state', passport.authenticate('jwt', { session: false }), (req, res) => {
    let updatedData = [];
    // Area.getStatesByName(req.body.state, (err, data) => {
    //     for (let i = 0; i < data.length; i++) {
    //         data[i].state = (req.body.newState);
    //         Area.addArea(data[i], (err, updated) => {
    //             if (err) {
    //                 res.json({ success: false, msg: 'Error occured', err: JSON.stringify(err) });
    //             } else {
    //                 updatedData.push(updated);
    //                 // console.log(updated)
    //             }
    //         });
    //     }
    //     res.json({ success: true, msg: 'State updated successfully', updated: updatedData })
    // });
    Area.updateState(req.body.state, req.body.newState, (err, data) => {
        if (err) {
            res.json({ success: false, msg: 'error', err: JSON.stringify(err) });
        } else {
            // console.log(updated)
            updatedData.push(data);
            res.json({ success: true, msg: 'State updated successfully', updated: data })
        }
    });
});

router.post('/edit-district', passport.authenticate('jwt', { session: false }), (req, res) => {
    let updatedData = [];
    // Area.getDistrictsByName(req.body.district, (err, data) => {
    //     for (let i = 0; i < data.length; i++) {
    //         data[i].district = (req.body.newDistrict);
    //         Area.addArea(data[i], (err, updated) => {
    //             if (err) {
    //                 res.json({ success: false, msg: 'Error occured', err: JSON.stringify(err) });
    //             } else {
    //                 updatedData.push(updated);
    //             }
    //         });
    //     }
    //     res.json({ success: true, msg: 'District updated successfully', updated: updatedData })
    // });
    Area.updateDistrict(req.body.district, req.body.newDistrict, (err, data) => {
        if (err) {
            res.json({ success: false, msg: 'error', err: JSON.stringify(err) });
        } else {
            // console.log(updated)
            updatedData.push(data);
            res.json({ success: true, msg: 'District updated successfully', updated: data })
        }
    });
});

router.post('/edit-city', passport.authenticate('jwt', { session: false }), (req, res) => {
    let updatedData = [];
    // Area.getCitiesByName(req.body.city, (err, data) => {
    //     for (let i = 0; i < data.length; i++) {
    //         data[i].city = (req.body.newCity);
    //         Area.addArea(data[i], (err, updated) => {
    //             if (err) {
    //                 res.json({ success: false, msg: 'Error occured', err: JSON.stringify(err) });
    //             } else {
    //                 updatedData.push(updated);
    //             }
    //         });
    //     }
    //     res.json({ success: true, msg: 'City updated successfully', updated: updatedData })
    // });
    Area.updateCity(req.body.city, req.body.newCity, (err, data) => {
        if (err) {
            res.json({ success: false, msg: 'error', err: JSON.stringify(err) });
        } else {
            // console.log(updated)
            updatedData.push(data);
            res.json({ success: true, msg: 'City updated successfully', updated: data })
        }
    });
});

// ******* Delete functions *********
router.post('/delete-country', passport.authenticate('jwt', { session: false }), (req, res) => {
    Area.getCountriesByName(req.body.country, (err, data) => {
        for (let i = 0; i < data.length; i++) {
            if (data[i].state) {
                return res.json({ success: false, msg: 'Country is used to create state' });
                break;
            } else if (data[i].city) {
                return res.json({ success: false, msg: 'Country is used to create state' })
                break;
            } else if (data[i].district) {
                return res.json({ success: false, msg: 'Country is used to create state' })
                break;
            }
        }
        Area.deleteCountry(req.body.country, (err, resp) => {
            if (err) {
                return res.json({ success: false, msg: 'Error in deletion country', err: JSON.stringify(err) });
            } else {
                return res.json({ success: true, msg: 'Country deleted successfully,,', resp: resp });
            }
        });
    });
});

router.post('/delete-state', passport.authenticate('jwt', { session: false }), (req, res) => {
    // console.log(req.body.state);
    Area.getStatesByName(req.body.state, (err, data) => {
        for (let i = 0; i < data.length; i++) {
            if (data[i].district) {
                return res.json({ success: false, msg: 'Error: State is used to create district' })
                break;
            } else if (data[i].city) {
                return res.json({ success: false, msg: 'Error: State is used to create city' })
                break;
            }
        }
        Area.deleteState(req.body.state, (err, resp) => {
            if (err) {
                res.json({ success: false, msg: 'Error in deletion state', err: JSON.stringify(err) });
            } else {
                res.json({ success: true, msg: 'State deleted successfully,,', resp: resp });
            }
        });
    });
});

router.post('/delete-district', passport.authenticate('jwt', { session: false }), (req, res) => {
    Area.getDistrictsByName(req.body.district, (err, data) => {
        for (let i = 0; i < data.length; i++) {
            if (data[i].city) {
                return res.json({ success: false, msg: 'Error: District is used to create city' })
                break;
            }
        }
        Area.deleteDistrict(req.body.district, (err, resp) => {
            if (err) {
                return res.json({ success: false, msg: 'Error in deletion District', err: JSON.stringify(err) });
            } else {
                return res.json({ success: true, msg: 'District deleted successfully,,', resp: resp });
            }
        });
    });
});

router.post('/delete-city', passport.authenticate('jwt', { session: false }), (req, res) => {
    Area.deleteCity(req.body.city, (err, resp) => {
        if (err) {
            return res.json({ success: false, msg: 'Error in deletion city', err: JSON.stringify(err) });
        } else {
            return res.json({ success: true, msg: 'City deleted successfully,,', resp: resp });
        }
    });
});

router.post('/getAreasByName',
    passport.authenticate('jwt', { session: false }),
    (req, res) => {
        const query = req.body.query;
        let uniqCoutries = [];
        let uniqStates = [];
        let uniqDistricts = [];
        let uniqCities = [];
        // res.json({ success: true, cities: [{ city: 'Bhopal' }] });
        Area.getCountriesByName(query, (err, cities) => {
            if (err) {
                res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
            } else {
                uniqCoutries = _.uniqBy(cities, (e) => e.country);
                for (const c of uniqCoutries) {
                    c.type = 'country';
                }
                // console.log(uniqCities);
                Area.getStatesByName(query, (err, cities) => {
                    if (err) {
                        res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                    } else {
                        uniqStates = _.uniqBy(cities, (e) => e.state);
                        for (const c of uniqStates) {
                            c.type = 'state';
                        }
                        // console.log(uniqCities);
                        Area.getDistrictsByName(query, (err, cities) => {
                            if (err) {
                                res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                            } else {
                                uniqDistricts = _.uniqBy(cities, (e) => e.district);
                                for (const c of uniqDistricts) {
                                    c.type = 'district';
                                }
                                // console.log(uniqCities);
                                Area.getCitiesByName(query, (err, cities) => {
                                    if (err) {
                                        res.json({ success: false, msg: 'Error in fetching cities of query ', err: JSON.stringify(err) });
                                    } else {
                                        uniqCities = _.uniqBy(cities, (e) => e.city);
                                        // console.log(uniqCoutries);
                                        // console.log(uniqStates);
                                        // console.log(uniqDistricts);
                                        // console.log(uniqCities);
                                        res.json({ success: true, msg: 'Cities are found', cities: uniqCities, districts: uniqDistricts, states: uniqStates, countries: uniqCoutries });
                                    }
                                });
                            }
                        });
                    }
                });
            }
        });
    });

module.exports = router;
