const _ = require('lodash');
const express = require('express');
const router = express.Router();
const passport = require('passport');
const Helpers = require('../Helpers/Helpers');
const District = require('../models/district');


router.post('/create-district', passport.authenticate('jwt', { session: false }), (req, res) => {
    District.getDistrictByName(Helpers.firstUpper(req.body.districtName), (err, district) => {
        if (err) {
            res.json({ success: false, msg: 'Error in creating district', err: JSON.stringify(err) });
        } else {
            if (district) {
                res.json({ success: false, msg: 'District is already exist' });
            } else {
                let newDistrict = new District({
                    name: Helpers.firstUpper(req.body.districtName),
                    state: Helpers.firstUpper(req.body.stateName),
                    country: Helpers.firstUpper(req.body.countryName),
                });

                District.addDistrict(newDistrict, (err, createdDist) => {
                    if (err) {
                        res.json({ success: false, msg: 'Error in creating district', err: JSON.stringify(err) });
                    } else {
                        if (createdDist) {
                            res.json({ success: true, msg: 'District created successfully', district: createdDist })
                        } else {
                            res.json({ success: false, msg: 'Error in creating district' })
                        }
                    }
                });
            }
        }
    });
});

router.post('/get-districts', passport.authenticate('jwt', { session: false }), (req, res) => {
    let dist = req.body.state;
    District.getDistrictByState(dist, (err, dists) => {
        if (err) {
            res.json({ success: false, msg: 'Error in creating district', err: JSON.stringify(err) });
        } else {
            res.json({ success: true, msg: 'Districts are found', districts: dists });
        }
    });
});

router.get('/get-all-district', passport.authenticate('jwt', { session: false }), (req, res) => {
    District.getDistricts((err, dists) => {
        if (err) {
            res.json({ success: false, msg: 'Error in creating district', err: JSON.stringify(err) });
        } else {
            res.json({ success: true, msg: 'Districts are found', districts: dists });
        }
    });
});

module.exports = router;