const FamilyIncome = require('../models/family-income');
const express = require('express');
const router = express.Router();



//route to create FamilyIncome
router.post('/create', (req, res) => {
	var familyIncome = req.body;
	FamilyIncome.addFamilyIncome(familyIncome, (err, familyIncome) => {
		if (err) {
			res.status(500).json({ success: false, msg: err });

		} else {
			res.status(201).json({ success: true, msg: 'Data added successfully', data: familyIncome });
		}

	});
});

//route to read FamilyIncome
router.get('/getAll', (req, res) => {
	FamilyIncome.getFamilyIncome((err, familyIncome) => {
		if (err) {
			res.status(500).json({ success: false, msg: err });
		} else {
			res.status(200).json({ success: true, data: familyIncome });
		}

	});
});

//route to find a familyIncome by id
router.get('/FamilyIncomeById/:family_income_id', (req, res) => {

	FamilyIncome.getFamilyIncomeById(req.params.family_income_id, (err, familyIncome) => {
		if (err) {
			res.status(500).json({ success: false, msg: err });
		} else {
			if (familyIncome === null) {
				res.status(200).json({ success: true, msg: "no familyIncome found by this id" });
			} else {
				res.status(200).json({ success: true, familyIncome: familyIncome });
			}
		}
	});
});

//route to find a familyIncome by title
router.get('/FamilyIncomeByTitle/:family_income_title', (req, res) => {

	FamilyIncome.getFamilyIncomeByTitle(req.params.family_income_title, (err, familyIncome) => {

		if (err) {
			res.status(500).json({ success: false, msg: err });
		} else {
			if (familyIncome === null) {
				res.status(200).json({ success: true, msg: "no familyIncome found by such title" });
			} else {
				res.status(200).json({ success: true, familyIncome: familyIncome });
			}

		}
	});
});




//route to update FamilyIncome
router.put('/update/:family_income_id', (req, res) => {
	var id = req.params.family_income_id;
	var familyIncome = req.body;
	FamilyIncome.updateFamilyIncome(id, familyIncome, {}, (err, familyIncome) => {
		if (err) {
			res.status(500).json({ success: false, msg: err });

		} else {
			console.log(familyIncome);
			res.status(200).json({ success: true, msg: 'Data updated successfully', data: familyIncome });
		}
	});
});

//route to delete FamilyIncome
router.delete('/delete/:family_income_id', (req, res) => {
	var id = req.params.family_income_id;
	FamilyIncome.removeFamilyIncome(id, (err, familyIncome) => {
		if (err) {
			res.status(500).json({ success: false, msg: err });

		} else {
			res.status(200).json({ success: true, msg: 'Data deleted successfully', data: familyIncome });
		}
	});
});



module.exports = router;


