const FamilyStatus = require('../models/family-status');
const express = require('express');
const router = express.Router();



//route to create FamilyStatus
router.post('/create', (req, res) => {
	var familyStatus = req.body;
	FamilyStatus.addFamilyStatus(familyStatus, (err, familyStatus) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, msg: 'Data created successfully',  data:familyStatus});
        }
		
	});
});

//route to read FamilyStatus
router.get('/getAll', (req, res) => {
	FamilyStatus.getFamilyStatus((err, familyStatus) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, data:familyStatus});
        }
		
	});
});

//route to find a familyStatus by id
router.get('/get/:family_status_id',(req,res)=>{
	
	FamilyStatus.getFamilyStatusById(req.params.family_status_id,(err,familyStatus)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(familyStatus===null){
				res.status(200).json({success:true, msg:"no familyStatus found by this id"});
				}else{
					res.status(200).json({success:true, data:familyStatus});
				}
            }
	});
});

//route to find a familyStatus by title
router.get('/FamilyStatusByTitle/:family_status_title',(req,res)=>{
	
	FamilyStatus.getFamilyStatusByTitle(req.params.family_status_title,(err,familyStatus)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(familyStatus===null){
			res.status(200).json({success:true, msg:"no familyStatus found by such title"});
			}else{
				res.status(200).json({success:true, familyStatus:familyStatus});
			}
            	
            }
	});
});

			
		

//route to update FamilyStatus
router.put('/update/:family_status_id', (req, res) => {
	var id = req.params.family_status_id;
	var familyStatus = req.body;
	FamilyStatus.updateFamilyStatus(id, familyStatus, {}, (err, familyStatus) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg: 'Data updated successfully', data:familyStatus});
        }
	});
});

//route to delete FamilyStatus
router.delete('/delete/:family_status_id', (req, res) => {
	var id = req.params.family_status_id;
	FamilyStatus.removeFamilyStatus(id, (err, familyStatus) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg: 'Data deleted successfully', data:familyStatus});
        }
	});
});



module.exports = router;


