const express = require('express');
const router = express.Router();
const passport = require('passport');
const Lead = require('../models/lead');
const User = require('../models/user');
const Office = require('../models/office');
const Member = require('../models/member');
const config = require('../config/database');
const OldLead = require('../models/oldLead');
const Transaction = require('../models/transaction');

router.post(
  '/create-member',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    let newMember = new Member({
      packageName: req.body.packageName,
      memberType: req.body.memberType,
      createdBy: req.body.user,
      //
      name: req.body.lead.name,
      mobile: req.body.lead.mobile,
      city: req.body.lead.city,
      state: req.body.lead.state,
      gender: req.body.lead.gender,
      followup: req.body.lead.followup,
      sendAddress: req.body.lead.sendAddress,
      messages: req.body.lead.messages
    });

    // adding in member
    Member.addMember(newMember, (err, member) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Error occured', err: err });
      } else {
        // adding in OldLeads
        let oldlead = new OldLead({
          name: req.body.lead.name,
          city: req.body.lead.city,
          state: req.body.lead.state,
          gender: req.body.lead.gender,
          mobile: req.body.lead.mobile,
          messages: req.body.lead.messages,
          followup: req.body.lead.followup,
          createdBy: req.body.lead.createdBy,
          sendAddress: req.body.lead.sendAddress
        });

        // adding in old members
        OldLead.addOldLead(oldlead, (err, lead) => {
          if (err) {
            res
              .status(200)
              .json({ success: false, msg: 'error occured', err: err });
          } else {
            // removing from leads
            Lead.deleteLeadById(req.body.lead._id, (err, lead) => {
              if (err) {
                res
                  .status(200)
                  .json({ success: false, msg: 'error occured', err: err });
              } else {
                // distribute amount to office and super admin
                Office.getOfficeById(req.body.officeId, (err, office) => {
                  if (err) {
                    res
                      .status(200)
                      .json({ success: false, msg: 'error occured', err: err });
                  } else {
                    if (office) {
                      // add transactions
                      // let officeTrans = new Transaction({
                      //   action: 'credit',
                      //   amount: req.body.officeAmount,
                      //   member: JSON.stringify(newMember),
                      //   newBal:
                      //     parseFloat(office.officeWallet) +
                      //     parseFloat(req.body.officeAmount),
                      //   from: req.body.user
                      // });
                      // Transaction.addTransaction(officeTrans, (err, trans) => {
                      //   if (err) {
                      //     res.status(200).json({
                      //       success: false,
                      //       msg: 'office transaction error',
                      //       err: err
                      //     });
                      //   }
                      // });
                      //

                      office.officeWallet =
                        parseFloat(office.officeWallet) +
                        parseFloat(req.body.officeAmount);
                      Office.addOffice(office, (err, office) => {
                        if (err) {
                          res.status(200).json({
                            success: false,
                            msg: 'error occured',
                            err: err
                          });
                        } else {
                          User.getSuperAdmin((err, user) => {
                            if (err) {
                              res.status(200).json({
                                success: false,
                                msg: 'error occured',
                                err: err
                              });
                            } else {
                              if (user) {
                                // add transactions
                                // let adminTrans = new Transaction({
                                //   action: 'credit',
                                //   amount: req.body.superAdminAmount,
                                //   member: JSON.stringify(newMember),
                                //   newBal:
                                //     parseFloat(user.wallet) +
                                //     parseFloat(req.body.superAdminAmount),
                                //   from: req.body.user
                                // });
                                // Transaction.addTransaction(
                                //   adminTrans,
                                //   (err, trans) => {
                                //     if (err) {
                                //       res.status(200).json({
                                //         success: false,
                                //         msg: 'super admin transaction error',
                                //         err: err
                                //       });
                                //     }
                                //   }
                                // );

                                // user.wallet =
                                //   parseFloat(user.wallet) +
                                //   parseFloat(req.body.superAdminAmount);
                                // console.log(user);
                                User.addUser(user, (err, user) => {
                                  if (err) {
                                    res.status(200).json({
                                      success: false,
                                      msg: 'error occured',
                                      err: err
                                    });
                                  } else {
                                    res.status(200).json({
                                      success: true,
                                      msg: 'member created successfully'
                                    });
                                  }
                                });
                              } else {
                                res.status(200).json({
                                  success: false,
                                  msg: 'super admin not found '
                                });
                              }
                            }
                          });
                        }
                      });
                    } else {
                      res
                        .status(200)
                        .json({ success: false, msg: 'Office not found' });
                    }
                  }
                });
              }
            });
          }
        });
      }
    });
  }
);

router.get(
  '/getAllMembers',
  passport.authenticate('jwt', { session: false }),
  (req, res) => {
    Member.getMembers((err, members) => {
      if (err) {
        res
          .status(200)
          .json({ success: false, msg: 'Error occured', err: err });
      } else {
        res
          .status(200)
          .json({ success: true, msg: 'members found', members: members });
      }
    });
  }
);

module.exports = router;
