const express = require("express");
const router = express.Router();
const passport = require("passport");
const memberController = require("./../controllers/new_memberController");

// router.post('/transferMember',memberController.addNewMember);
router.post(
  "/createNewMember",
  passport.authenticate("jwt", { session: false }),
  memberController.createNewMember
);

router.post(
  "/createNewMemberByMember",
  memberController.createNewMemberByWebsite
);
router.get("/getByMemberId/:id", memberController.getMemberByMemberId);
router.post(
  "/getFilteredMembers/:fromYear/:toYear/:page/:sort",
  memberController.getFilteredMembers
);
router.get("/transferNewestMember", memberController.addNewestMember);
router.post("/getPartnerPreference", memberController.getPartnerPreference);
router.get("/getAllFilters", memberController.getAllFilters);
router.get("/getUnapprovedMembers", memberController.getUnapprovedMembers);
router.get("/getLessPlanMemberIds", memberController.getLessPlanMemberIdsFunc);
router.get(
  "/getMembersInAgeRange/:fromYear/:toYear",
  memberController.getMembersInAgeRange
);
router.get("/getMemberAge/:_id", memberController.getMembersAge);
router.get("/getMembersAddedBy/:addedBy", memberController.getMembersAddedBy);
router.get("/getNewMembers/:page/:sort", memberController.getAllMembers);
router.get("/search/:page/:keyword", memberController.searchNewMember);
router.get("/searchById/:page/:keyword", memberController.searchNewMemberById);
router.get("/getLessPlanMembers", memberController.getLessPlanMembers);
router.get("/getMember/:_id", memberController.getMember);
router.get("/getAllMembers/:page/:sort", memberController.getAllMembers);
router.post("/getAllMembersByIds",
  passport.authenticate("jwt", { session: false }),
  memberController.getAllMembersByIds);
router.put(
  "/reqUpdateMember",
  passport.authenticate("jwt", { session: false }),
  memberController.reqUpdateMember
);
router.put(
  "/reqUpdateMemberByMember",
  memberController.reqUpdateMemberByMember
);
router.put("/updateMember",
  passport.authenticate("jwt", { session: false }), memberController.updateMember);
router.put("/adminUpdateMember",
  passport.authenticate("jwt", { session: false }), memberController.adminUpdateMember);
router.put("/updatePlan",
  passport.authenticate("jwt", { session: false }), memberController.updateMemberPlan);
router.delete("/deleteMember/:_id",
  passport.authenticate("jwt", { session: false }), memberController.deleteMember);
router.post("/generatePassword",
  passport.authenticate("jwt", { session: false }), memberController.generatePass);
router.post("/generatePasswordForAll",
  // passport.authenticate("jwt", { session: false }),
  memberController.generatePassForAll);
router.post("/getMemInEvent", memberController.getMemInEvent);
router.get("/getMemInEventCount/:eventId", memberController.getMemInEventCount);
router.post("/authMember", memberController.authMember);
router.get("/getDupMembers", memberController.getDupMembers);
router.get("/getDupMembersByEmail", memberController.getDupMembersByEmail);
router.get("/getDupMembersByName", memberController.getDupMembersByName);
router.get("/getDupMembersCount", memberController.getDupMembersCount);
router.get(
  "/getDupMembersByEmailCount",
  memberController.getDupMembersByEmailCount
);
router.get(
  "/getDupMembersByNameCount",
  memberController.getDupMembersByNameCount
);
router.post("/getMembersByMobile", memberController.getMembersByMobile);
router.get(
  "/getSuggestedProfileFor/:id",
  memberController.getSuggestedProfileFor
);
router.get(
  "/getSuggestedProfileFor/:id/:evIds",
  memberController.getSuggestedProfileFor
);
router.get(
  "/sendIdPasswordToMember/:id",
  passport.authenticate("jwt", { session: false }),
  memberController.sendIdPasswordToMember
);
router.post(
  "/sendMsgToMember",
  passport.authenticate("jwt", { session: false }),
  memberController.sendMsgToMember
);

router.post(
  "/getMatchesByPartnerPrefrence",
  // passport.authenticate("jwt", { session: false }),
  memberController.getMatchesByPartnerPrefrence
);
router.get(
  "/deleteValidatedData",
  memberController.deleteValidatedData
);

module.exports = router;
