const Occupation = require('../models/occupation');
const express = require('express');
const router = express.Router();



//route to create Occupation
router.post('/create', (req, res) => {
	var occupation = req.body;
	Occupation.addOccupation(occupation, (err, occupation) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, msg: 'Data created successfully', data:occupation});
        }
		
	});
});

//route to read Occupation
router.get('/getAll', (req, res) => {
	Occupation.getOccupation((err, Occupation) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, data:Occupation});
        }
		
	});
});

//route to find a occupation by id
router.get('/get/:occupation_id',(req,res)=>{
	
	Occupation.getOccupationById(req.params.occupation_id,(err,occupation)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(occupation===null){
				res.status(200).json({success:true, msg:"no occupation found by this id"});
				}else{
					res.status(200).json({success:true, occupation:occupation});
				}
            }
	});
});

//route to find a occupation by title
router.get('/OccupationByTitle/:occupation_title',(req,res)=>{
	
	Occupation.getOccupationByTitle(req.params.occupation_title,(err,occupation)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(occupation===null){
			res.status(200).json({success:true, msg:"no eoccupation found by such title"});
			}else{
				res.status(200).json({success:true, occupation:occupation});
			}
            	
            }
	});
});

			
		

//route to update Occupation
router.put('/update/:occupation_id', (req, res) => {
	var id = req.params.occupation_id;
	var occupation = req.body;
	Occupation.updateOccupation(id, occupation, {}, (err, occupation) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg: 'Data updated occupation', data:occupation});
        }
	});
});

//route to delete Occupation
router.delete('/delete/:occupation_id', (req, res) => {
	var id = req.params.occupation_id;
	Occupation.removeOccupation(id, (err, occupation) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg : 'Data deleted successfully',  data:occupation});
        }
	});
});



module.exports = router;


