const ProfessionalStatus = require('../models/professional-status');
const express = require('express');
const router = express.Router();



//route to create ProfessionalStatus
router.post('/create', (req, res) => {
	var professionalStatus = req.body;
	ProfessionalStatus.addProfessionalStatus(professionalStatus, (err, professionalStatus) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(201).json({success:true, msg: 'Data added successfully',  data:professionalStatus});
        }
		
	});
});

//route to read ProfessionalStatus
router.get('/getAll', (req, res) => {
	ProfessionalStatus.getProfessionalStatus((err, ProfessionalStatuses) => {
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
            res.status(200).json({success:true, data:ProfessionalStatuses});
        }
		
	});
});

//route to find a professionalStatus by id
router.get('/get/:professional_status_id',(req,res)=>{
	
	ProfessionalStatus.getProfessionalStatusById(req.params.professional_status_id,(err,professionalStatus)=>{
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(professionalStatus===null){
				res.status(200).json({success:true, msg:"no professionalStatus found by this id"});
				}else{
					res.status(200).json({success:true,  professionalStatus:professionalStatus});
				}
            }
	});
});

//route to find a professionalStatus by title
router.get('/ProfessionalStatusByTitle/:professional_status_title',(req,res)=>{
	
	ProfessionalStatus.getProfessionalStatusByTitle(req.params.professional_status_title,(err,professionalStatus)=>{
		
		if(err){
			res.status(500).json({success:false, msg:err});
		}else{
			if(professionalStatus===null){
			res.status(200).json({success:true, msg:"no professionalStatus found by such title"});
			}else{
				res.status(200).json({success:true, professionalStatus:professionalStatus});
			}
            	
            }
	});
});

			
		

//route to update ProfessionalStatus
router.put('/update/:professional_status_id', (req, res) => {
	var id = req.params.professional_status_id;
	var professionalStatus = req.body;
	ProfessionalStatus.updateProfessionalStatus(id, professionalStatus, {}, (err, professionalStatus) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true, msg: 'Data updated successfully',data:professionalStatus});
        }
	});
});

//route to delete ProfessionalStatus
router.delete('/delete/:professional_status_id', (req, res) => {
	var id = req.params.professional_status_id;
	ProfessionalStatus.removeProfessionalStatus(id, (err, professionalStatus) => {
		if(err){
            res.status(500).json({success:false, msg:err});
            
		}else{
            res.status(200).json({success:true,msg : 'Data deleted successfully', data:professionalStatus});
        }
	});
});



module.exports = router;


